create table authorizedUser
(
 authorizedID TINYINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
 authorizedName VARCHAR(32) NOT NULL DEFAULT ' ',
 authorizedPassKey VARCHAR(16) NOT NULL DEFAULT ' ',
 authorizedLevel TINYINT(1) UNSIGNED DEFAULT '2',
 authorizedValid ENUM('Y','N') NOT NULL DEFAULT 'Y'
)type=innodb;

create table transaction
(
 transKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 transInvoiceNo INT UNSIGNED NOT NULL DEFAULT '0',
 transDescription VARCHAR(64) NOT NULL DEFAULT ' ',
 transValid ENUM('Y','N') NOT NULL DEFAULT 'Y',
 transTime TIME NOT NULL DEFAULT '00:00:00',
 transDate DATE NOT NULL DEFAULT '0000-00-00',
 PRIMARY KEY (transKey,transInvoiceNo)
)type=innodb;

create table transDocument
(
 transDocKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 transDocOfKey INT UNSIGNED NOT NULL DEFAULT '0',
 transDocNo VARCHAR(32) NOT NULL DEFAULT ' ',
 PRIMARY KEY(transDocKey,transDocOfKey)
)type=innodb;

create table transRemarks
(
 transRemarksKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 transRemarksContent VARCHAR(128) NOT NULL DEFAULT ' ',
 transRemarksOfKey INT UNSIGNED NOT NULL DEFAULT '0',
 PRIMARY KEY(transRemarksKey,transRemarksOfKey)
)type=innodb;

create table transAudit
(
 transAuditKey INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
 transAuditOfKey INT UNSIGNED NOT NULL DEFAULT '0',
 transAuditByID TINYINT UNSIGNED NOT NULL DEFAULT '0',
 transAuditTime TIME NOT NULL DEFAULT '00:00:00',
 transAuditDate DATE NOT NULL DEFAULT '0000-00-00'
)type=innodb;

create table transPayment
(
 transPaymentKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 transPaymentMethod VARCHAR(16) NOT NULL DEFAULT 'CASH',
 transPaymentType ENUM('DEBIT','CREDIT') NOT NULL DEFAULT 'DEBIT',
 transPaymentCurr VARCHAR(3) NOT NULL DEFAULT 'IDR',
 transPaymentAmnt DECIMAL(14,2) NOT NULL DEFAULT '0.00',
 transPaymentOfKey INT UNSIGNED NOT NULL DEFAULT '0',
 transPaymentDate DATE NOT NULL DEFAULT '0000-00-00',
 transPaymentTime TIME NOT NULL DEFAULT '00:00:00',
 transPaymentChangedBy TINYINT UNSIGNED NOT NULL DEFAULT '0',
 transPaymentChangedTime TIME NOT NULL DEFAULT '00:00:00',
 transPaymentChangedDate DATE NOT NULL DEFAULT '0000-00-00',
 PRIMARY KEY(transPaymentKey,transPaymentOfKey)
)type=innodb;

create table transBalance
(
 transBalanceKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 transBalanceCurrency VARCHAR(3) NOT NULL DEFAULT 'IDR',
 transBalanceAmount DECIMAL(14,2) NOT NULL DEFAULT '0.00',
 transBalanceDate DATE NOT NULL DEFAULT '0000-00-00',
 PRIMARY KEY(transBalanceKey,transBalanceDate)
)type=innodb;

create table transBankBalance
(
 transBankBalKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 transBankBalCurrency VARCHAR(3) NOT NULL DEFAULT 'IDR',
 transBankBalAmount DECIMAL(14,2) NOT NULL DEFAULT '0.00',
 transBankBalDate DATE NOT NULL DEFAULT '0000-00-00',
 PRIMARY KEY(transBankBalKey,transBankBalDate)
)type=innodb;

create table transInitialBalance
(
 transInitialKey TINYINT UNSIGNED NOT NULL AUTO_INCREMENT,
 transInitialCurrency VARCHAR(3) NOT NULL DEFAULT 'IDR',
 transInitialAmount DECIMAL(14,2) NOT NULL DEFAULT '0.00',
 transInitialDate DATE NOT NULL DEFAULT '0000-00-00',
 transInitialChangeID TINYINT UNSIGNED NOT NULL DEFAULT '0',
 PRIMARY KEY(transInitialKey,transInitialChangeID)
)type=innodb;

create table transInitialBankBalance
(
 transInitialBankBalKey TINYINT UNSIGNED NOT NULL AUTO_INCREMENT,
 transInitialBankBalCurrency VARCHAR(3) NOT NULL DEFAULT 'IDR',
 transInitialBankBalAmount DECIMAL(14,2) NOT NULL DEFAULT '0.00',
 transInitialBankBalDate DATE NOT NULL DEFAULT '0000-00-00',
 transInitialBankBalChangeID TINYINT UNSIGNED NOT NULL DEFAULT '0',
 PRIMARY KEY(transInitialBankBalKey,transInitialBankBalChangeID)
)type=innodb;
