import java.sql.SQLException;
import java.math.BigDecimal;
import java.util.Vector;

public class Balance
{
 private static int BANK = 0;
 private static int CASH = 1;

 public static int commitType = 0;
 public static int editType = 1;
 public static int addType = 2;

 public Balance() { } 

 public static void rebalance(int type,String date,DBConnect db) 
	throws SQLException
 {
  DateUtil du;
  if(date == null)
   du = new DateUtil();
  else
   du = new DateUtil(date);

  String cDate = du.formSQLDate();
  DateUtil yesterday = new DateUtil(cDate);
  DateUtil yesLimit = new DateUtil(cDate);
  yesterday.addCalendar(1,-1);
  yesLimit.addCalendar(1,-7);
  String p1Date = yesterday.formSQLDate();
  String p2Date = yesLimit.formSQLDate();
  System.out.println("today: "+cDate+" yesterday: "+p1Date+
  " yesLimit: "+p2Date);

  du.clearCalendar();
  yesterday.clearCalendar();
  yesLimit.clearCalendar();
  yesterday = null;
  yesLimit = null;
  du = null;

  MultipleCurrency masterMC = sumOfDay(CASH,cDate,db);
  Vector balance = db.QueryMulti("transBalance","*",
  "WHERE transBalanceDate=\""+cDate+"\";");

  if(balance == null) // no balance for the current date
   processPast(CASH,type,cDate,p1Date,p2Date,masterMC,db);
  else // there is a balance for the current date
   processCurrent(CASH,type,cDate,masterMC,balance,db);
  
  if(balance != null && !balance.isEmpty()) balance.removeAllElements();
  if(masterMC != null) masterMC.clearVariable();

  masterMC = sumOfDay(BANK,cDate,db);

  balance = db.QueryMulti("transBankBalance","*",
  "WHERE transBankBalDate=\""+cDate+"\";");

  if(balance == null)
   processPast(BANK,type,cDate,p1Date,p2Date,masterMC,db);
  else
   processCurrent(BANK,type,cDate,masterMC,balance,db);

  if(masterMC != null) masterMC.eraseAll();
  masterMC = null;
  return;
 }


/**
 * processPast's method is to process the no-today-balance entry
 * @param int action   - CASH or BANK
 *        String cDate - current date
 *        String yes1  - yesterday date
 *        String yes2  - 2nd limit of date [4 days from cDate]
 *        MultipleCurrency mc - total sum of cDate
 *        DBConnect db - connection to database
 * @return none
 */
 protected static void processPast(
  int action,
  int typeAction,
  String cDate,
  String yes1,
  String yes2,
  MultipleCurrency mc,
  DBConnect db) 
  throws SQLException
 {
  System.out.print(" --- processPast start for ");
  if(action == CASH)
   System.out.println("CASH --- ");
  else
   System.out.println("BANK --- ");
  if(mc == null)
  {
   System.out.println("mc is null so exit so create empty one");
   mc = new MultipleCurrency(Mandalatama.typeCurrency);
  }
  Encap e = null;
  int size = Mandalatama.typeCurrency.length;
  int counter=0;
  MultipleCurrency mcBalance = new MultipleCurrency(Mandalatama.typeCurrency);

  // fetch today initial balance
  Vector v1 = null;
  
  if(action == CASH)
   v1 = db.QueryMulti("transInitialBalance","*",
   "WHERE transInitialDate=\""+cDate+"\";"); 
  else
   v1 = db.QueryMulti("transInitialBankBalance","*",
   "WHERE transInitialBankBalDate=\""+cDate+"\";");

  if(v1 != null) 
  { // today initial balance exists
   while(!v1.isEmpty())
   {
    e = (Encap)v1.remove(0);
    if(action == CASH)
     mcBalance.sumAR(e.extractString("transInitialCurrency",null),
     e.extractAll("transInitialAmount"));
    else
     mcBalance.sumAR(e.extractString("transInitialBankBalCurrency",null),
     e.extractAll("transInitialBankBalAmount"));
    e.clear();
   }
  }
  else 
  { // today initial balance non-existance
    // fetch yesterday balance

   if(action == CASH)
    v1 = db.QueryMulti("transBalance","*",
    "WHERE transBalanceDate<=\""+yes1+"\" AND "+
    "transBalanceDate>=\""+yes2+"\""+
    "ORDER BY transBalanceDate DESC LIMIT 4;");
   else
    v1 = db.QueryMulti("transBankBalance","*",
    "WHERE transBankBalDate<=\""+yes1+"\" AND "+
    "transBankBalDate>=\""+yes2+"\""+
    "ORDER BY transBankBalDate DESC LIMIT 4;");
   if(v1 != null)
   {
    counter = 0;
    System.out.println("found balance of yes1 and yes2");
    while(!v1.isEmpty())
    {
     e = (Encap)v1.remove(0);
     if(action == CASH)
      mcBalance.sumAR(e.extractString("transBalanceCurrency",null),
      e.extractAll("transBalanceAmount"));
     else
      mcBalance.sumAR(e.extractString("transBankBalCurrency",null),
      e.extractAll("transBankBalAmount"));
     e.clear();
    }
   }
   else //brand new account so create everything
   {
    System.out.println("no balance found");
    e = new Encap();
    v1= new Vector(4);
   }
  }
  
  Vector future = null;
  if(action == CASH)
   future = db.QueryMulti("transBalance","*",
   "WHERE transBalanceDate>\""+cDate+"\" "+
   "ORDER BY transBalanceDate DESC LIMIT 1;");
  else
   future = db.QueryMulti("transBankBalance","*",
   "WHERE transBankBalDate>\""+cDate+"\" "+
   "ORDER BY transBankBalDate DESC LIMIT 1;");

  boolean futureExist = false;
  if(future != null)
  {
   futureExist = true;
   future.removeAllElements();
   future = new Vector(4);
  }
  StringBuffer q = new StringBuffer(64);
  BigDecimal different = new BigDecimal("0.00");

  for(int i=0;i<size;i++)
  {
   if(action == CASH)
   {
    if(futureExist)
    {
     different = mc.getSumAR(i).subtract(mcBalance.getSumAR(i));
     System.out.println("different: "+different.toString());
     q.append("UPDATE transBalance SET transBalanceAmount=");
     q.append("(transBalanceAmount+"+different.toString()+")");
     q.append(" WHERE transBalanceCurrency=\""+mcBalance.getCurr(i)+"\"");
     q.append(" AND transBalanceDate>\""+cDate+"\";"); 
     future.add(q.toString());
    }
    mcBalance.sumAR(mc.getCurr(i),mc.getSumAR(i).toString());
    e.setTable("transBalance");
    e.setNameVal("transBalanceCurrency",mcBalance.getCurr(i));
    e.setNameVal("transBalanceAmount",mcBalance.getSumAR(i));
    e.setNameVal("transBalanceDate",cDate);
   }
   else
   {
    if(futureExist)
    {
     different = mc.getSumAR(i).subtract(mcBalance.getSumAP(i));
     System.out.println("different: "+different.toString());
     q.append("UPDATE transBankBalance SET transBankBalAmount=");
     q.append("(transBankBalAmount+"+different.toString()+")");
     q.append(" WHERE transBankBalCurrency=\""+mcBalance.getCurr(i)+"\"");
     q.append(" AND transBankBalDate>\""+cDate+"\";"); 
     future.add(q.toString());
    }
    mcBalance.sumAR(mc.getCurr(i),mc.getSumAP(i).toString());
    e.setTable("transBankBalance");
    e.setNameVal("transBankBalCurrency",mcBalance.getCurr(i));
    e.setNameVal("transBankBalAmount",mcBalance.getSumAR(i));
    e.setNameVal("transBankBalDate",cDate);
   }
   if(q.length() > 0) q.delete(0,q.length());
   v1.add(e.clone());
   e.clear();
  } 
  db.InsertMulti((Vector)v1.clone());
  if(futureExist)
  {
   db.UpdateSpecialMany((Vector)future.clone());
   future.removeAllElements();
   future = null;
  }
  v1.removeAllElements();
 } // end of processPast

/**
 * processCurrent's method is to today balance with the new addition
 * @param String cDate - current Date, 
 *        MultipleCurrency mc - sum of today,
 *        Vector todayBal - balance of today, 
 *        DBConnect db
 * @return none
 */
 protected static void processCurrent(int action,int typeAction,String cDate,
	 MultipleCurrency mc,Vector todayBal,DBConnect db)
  throws SQLException
 {
  System.out.print(" --- processCurrent start for ");
  if(action == CASH)
   System.out.println("CASH --- ");
  else
   System.out.println("BANK --- ");
  int size = Mandalatama.typeCurrency.length;
  int counter = 0;
  Encap e = null;
  boolean initExist = false;
  if(mc == null)
  {
   System.out.println("mc is null so create new. Meant no balance today");
   mc = new MultipleCurrency(Mandalatama.typeCurrency);
  }
  MultipleCurrency mcBalance = new MultipleCurrency(Mandalatama.typeCurrency);
  
  Vector v1 = null; 
  // check for new initial balance
  if(action == CASH)
   v1 = db.QueryMulti("transInitialBalance","*",
   "WHERE transInitialDate=\""+cDate+"\";");
  else
   v1 = db.QueryMulti("transInitialBankBalance","*",
   "WHERE transInitialBankBalDate=\""+cDate+"\";");

  if(v1 != null) // new initial exist
  {
   initExist = true;
   while(!v1.isEmpty())
   {
    e = (Encap)v1.remove(0);
    if(action == CASH)
     mcBalance.sumAR(e.extractString("transInitCurrency",null),
     e.extractAll("transInitAmount"));
    else
     mcBalance.sumAR(e.extractString("transInitialBankBalCurrency",null),
     e.extractAll("transInitialBankBalAmount"));
    e.clear();
   }
  }
  else // no new initial so resume the todayBalance
  {
   v1 = new Vector(4);
   while(!todayBal.isEmpty())
   {
    e = (Encap)todayBal.remove(0);
    if(action == CASH)
     mcBalance.sumAR(e.extractString("transBalanceCurrency",null),
      e.extractAll("transBalanceAmount"));
    else
     mcBalance.sumAR(e.extractString("transBankBalCurrency",null),
      e.extractAll("transBankBalAmount"));
    e.clear();
   }
  }

  String tableName = null;
  StringBuffer q = new StringBuffer(64);

  BigDecimal different = new BigDecimal("0.00");

  if(action == CASH)
   tableName = new String("transBalance");
  else
   tableName = new String("transBankBalance");

  for(int i=0;i<size;i++)
  {
   different = mc.getSumAR(i).subtract(mcBalance.getSumAR(i));
   System.out.print("mc = "+mc.getSumAR(i).toString()+" - ");
   System.out.print("mcBalance = "+mcBalance.getSumAR(i).toString());
   System.out.println(" different: "+different.toString());
   if(action == CASH)
   {
    q.append("UPDATE "+tableName+" SET transBalanceAmount=");
    q.append("(transBalanceAmount+"+different.toString()+")");
    q.append(" WHERE transBalanceCurrency=\""+mcBalance.getCurr(i)+"\"");
    q.append(" AND transBalanceDate>=\""+cDate+"\";"); 
   }
   else
   {
    q.append("UPDATE "+tableName+" SET transBankBalAmount=");
    q.append("(transBankBalAmount+"+different.toString()+")");
    q.append(" WHERE transBankBalCurrency=\""+mcBalance.getCurr(i)+"\"");
    q.append(" AND transBankBalDate>=\""+cDate+"\";");
   }
   v1.add(q.toString());
   q.delete(0,q.length());
  }
  db.UpdateSpecialMany((Vector)v1.clone());
  v1.removeAllElements();
 }

/**
 * sumOfDay's method is to calculate the total transaction of the day.
 * It returns MultipleCurrency with AR contains all the CASH/TRANSFER 
 * AP contains all the non-cash
 * @param String date - the date of transaction,DBConnect db - connect to db
 * @return MultipleCurrency of the total of transaction 
 */
 public static MultipleCurrency sumOfDay(int act,String date,DBConnect db) 
  throws SQLException
 {
  MultipleCurrency mc = new MultipleCurrency(Mandalatama.typeCurrency);
  Vector v;
  if(act == CASH)
   v = db.QueryMulti("transPayment","*","WHERE transPaymentDate=\""+date+
   "\" AND transPaymentMethod=\"CASH\";");
  else
   v = db.QueryMulti("transPayment","*","WHERE transPaymentDate=\""+date+
   "\" AND transPaymentMethod<>\"CASH\";");

  if(v != null)
  {
   Encap e = null;
   while(!v.isEmpty())
   {
    e = (Encap)v.remove(0);
    if(e.extractAll("transPaymentType").equalsIgnoreCase("DEBIT"))
    {
     mc.sumAR(e.extractString("transPaymentCurr",null),
     e.extractAll("transPaymentAmnt"));
     System.out.println("DEBIT : "+e.extractAll("transPaymentCurr")+
     " "+e.extractAll("transPaymentAmnt"));
    }
    else
    {
     mc.subAR(e.extractString("transPaymentCurr",null),
     e.extractAll("transPaymentAmnt"));
     System.out.println("CREDIT : "+e.extractAll("transPaymentCurr")+
     " "+e.extractAll("transPaymentAmnt"));
    }
    e.clear();
    for(int i=0;i<Mandalatama.typeCurrency.length;i++)
    {
     System.out.print("sumOfDay ["+date+"]: ");
     System.out.println(mc.getCurr(i)+" "+mc.getSumAR(i).toString());
    }
    
   } // end of while-loop
  }
  else
  {
   System.out.println("sumOfDay ["+date+"] is null");
   mc = null;
  }
  return mc;
 }
}
