import java.util.Vector;
import java.sql.SQLException;
import javax.swing.JOptionPane;

public class Commit
{
 private StringBuffer error = new StringBuffer(56);
 private double leftoverSum = 0.00;
 private String date = null;

 public Commit(Encap en)
 {
  if(en == null)
  {
   Mandalatama.errorDisplay("Received null value","ERROR");
   return;
  }
  if(en.getSize()<1)
  {
   Mandalatama.errorDisplay("Received no content","ERROR");
   return;
  }
  int pos = en.getPosition("invDate");
  if(pos>=0)
   date = DateUtil.formSQLDate(en.getValue(pos));

  boolean successFlag = startCommit(en);
  if(successFlag)
   Mandalatama.infoDisplay("Successfully insert data to database","INFO");
  else
   Mandalatama.errorDisplay(error.toString(),"ERROR");
  return;
 }

 private boolean startCommit(Encap en)
 {
  DBConnect db = new DBConnect();
  Encap prev = null;
  Encap result = null;
  boolean flag = true;
  boolean happen = false;
	boolean cancelFlag = false;
  try
  {
   if(!db.makeConnection("MANDALATAMA"))
    throw new SQLException("Failure to make connection to database\n");
   if(en.getPosition("invNo")>=0)
   {
    prev = db.QuerySingle("transaction","*","WHERE transInvoiceNo="+
     en.extractAll("invNo")+";");
    if(prev != null) // invoice number exist 
		{
		 int opt= JOptionPane.showConfirmDialog(null,"Transaction exist before!",
		 "transaction with invoice no: "+
		 en.extractAll("invNo")+" exist before. Do you want to continue?",
		 JOptionPane.YES_NO_OPTION);
		 if(opt == JOptionPane.YES_OPTION)
      flag = processAdditional(prev,en,db);
		 else 
		 {
			error.append("Transaction has been cancel\n");
			cancelFlag = true;
		 }
		}
    else // invoice number non-exist in database
     flag = processNormal(en,db);
   } // no invoice number found in the transaction
   else 
    flag = processNormal(en,db);
   if(flag && !cancelFlag)
    addDayBalance(en,db);
  }
  catch(SQLException sqle)
  {
   error.append(sqle.getMessage());
   sqle.printStackTrace(System.out);
   flag = false;
  }
  finally
  {
   db.close();
   db = null;
  }
  return flag;
 }

 private void addDayBalance(Encap e,DBConnect db) throws SQLException
 {
  if(e == null) throw new SQLException("Empty encap to add day balance");
  int pos = e.getPosition("invDate");
  String dateCommit = null;
  if(pos >= 0)
   dateCommit = DateUtil.formSQLDate(e.getValue(pos));
  boolean cashTransaction = VariousCheck.checkException(
   e.extractAll("method"));
  String signing = null;
	if(e.extractAll("type").equalsIgnoreCase("DEBIT"))
	 signing = new String("+");
	else
	 signing = new String("-");
  if(cashTransaction) // CASH TRANSACTION
  {
   addCashBalance(dateCommit,e.extractString("currency",null),
   signing+e.extractAll("invAmount"),db); 
  }
  else // NON-CASH TRANSACTION
  {
   addNonCashBalance(dateCommit,e.extractString("currency",null),
   signing+e.extractAll("invAmount"),db);
  }
 }

 private void addCashBalance(String date,String curr,String amt,
  DBConnect db) throws SQLException
 {
  Encap sample;
  if(date == null) 
   sample = db.QuerySingle("transBalance","*",
   "WHERE transBalanceDate=CURRENT_DATE ORDER BY transBalanceKey "+
   "DESC LIMIT 1;");
  else
   sample = db.QuerySingle("transBalance","*",
   "WHERE transBalanceDate=\""+date+"\" ORDER BY transBalanceKey "+
   "DESC LIMIT 1;");
  
  if(sample == null) // no balance today
  {
   addToNoBalance(date,curr,amt,db);
  }
  else // there is balance today so Update the balance
  {
   StringBuffer setting = new StringBuffer(64);
   StringBuffer condition = new StringBuffer(64);
   setting.append("transBalanceAmount=(transBalanceAmount"+amt+") ");
   condition.append("WHERE transBalanceCurrency=\""+curr+"\" AND ");
   if(date == null)
    condition.append("transBalanceDate>=CURRENT_DATE;");
   else
    condition.append("transBalanceDate>=\""+date+"\";");
   db.UpdateSpecial("transBalance",setting.toString(),condition.toString());
   setting.delete(0,setting.length());
   condition.delete(0,condition.length());
  }
 }

 private void addToNoBalance(String date,String curr,String amt,
  DBConnect db) throws SQLException
 {
  Encap e = new Encap();
  int len = Mandalatama.typeCurrency.length;
  DateUtil du = null;
  if(date == null)
  {
   du = new DateUtil();
   date = du.formSQLDate();
  }
  else
   du = new DateUtil(date);
  
  DateUtil aDayBefore = new DateUtil(date);
  DateUtil aWeekAgo = new DateUtil(date);
  aDayBefore.addCalendar(1,-1);
  aWeekAgo.addCalendar(1,-14);
  String d1 = aDayBefore.formSQLDate();
  String d2 = aWeekAgo.formSQLDate();
  aDayBefore.clearCalendar();
  aWeekAgo.clearCalendar();
  du.clearCalendar();
  du = null;
  aWeekAgo = null;
  aDayBefore = null;

  Vector v1 = db.QueryMulti("transBalance","*",
  "WHERE transBalanceDate<=\""+d1+"\" AND "+
  "transBalanceDate>=\""+d2+"\" "+
  "ORDER BY transBalanceDate DESC LIMIT 4;");

  boolean pastExist = false;
  boolean futureExist = false;
  MultipleCurrency balance = new MultipleCurrency(Mandalatama.typeCurrency);

  if(v1 != null)
  {
   while(!v1.isEmpty())
   {
    e = (Encap)v1.remove(0);
    balance.sumAR(e.extractString("transBalanceCurrency",null),
    e.extractAll("transBalanceAmount"));
    e.clear();
   } 
   pastExist = true;
   v1 = null;
  }

  v1 = db.QueryMulti("transBalance","*",
  "WHERE transBalanceDate>\""+date+"\" "+
  "ORDER BY transBalanceDate DESC LIMIT 1;");
  if(v1 != null)
  {
   futureExist = true;
   v1.removeAllElements();
  }

  Vector v = new Vector(len);
  for(int i=0;i<len;i++)
  {
   e.setTable("transBalance");
   e.setNameVal("transBalanceDate",date);

   if(curr.equalsIgnoreCase(Mandalatama.typeCurrency[i]))
   {
    e.setNameVal("transBalanceCurrency",curr);
    if(pastExist)
    {
     balance.sumAR(curr,amt);
     e.setNameVal("transBalanceAmount",balance.getSumAR(i).toString());
    }
    else
     e.setNameVal("transBalanceAmount",amt);
    if(futureExist)
    {
     StringBuffer q = new StringBuffer(64);
     q.append("UPDATE transBalance SET transBalanceAmount=");
     q.append("(transBalanceAmount+"+amt+") ");
     q.append("WHERE transBalanceCurrency=\""+curr+"\" ");
     q.append("AND transBalanceDate>\""+date+"\";");
     v1.add(q.toString());
     q.delete(0,q.length());
    }
   }
   else
   {
    e.setNameVal("transBalanceCurrency",Mandalatama.typeCurrency[i]);
    e.setNameVal("transBalanceAmount",balance.getSumAR(i).toString());
   }
   v.add(e.clone());
   e.clear();
  }
  db.InsertMulti((Vector)v.clone());
  if(v1 != null)
  {
   if(!v1.isEmpty())
   {
    db.UpdateSpecialMany((Vector)v1.clone());
    v1.removeAllElements();
   }
  }
  v.removeAllElements();
  v = null;
  e = null;
 }

 private void addNonCashBalance(String date,String curr,String amt,
  DBConnect db) throws SQLException
 {
  Encap sample;
  if(date == null) 
   sample = db.QuerySingle("transBankBalance","*",
   "WHERE transBankBalDate=CURRENT_DATE ORDER BY transBankBalKey "+
   "DESC LIMIT 1;");
  else
   sample = db.QuerySingle("transBankBalance","*",
   "WHERE transBankBalDate=\""+date+"\" ORDER BY transBankBalKey "+
   "DESC LIMIT 1;");

  if(sample == null) // no balance today
  {
   addToNoBankBalance(date,curr,amt,db);
  }
  else // there is balance today so update the balance
  {
   StringBuffer setting = new StringBuffer(64);
   StringBuffer condition = new StringBuffer(64);
   setting.append("transBankBalAmount=(transBankBalAmount+"+amt+") ");
   condition.append("WHERE transBankBalCurrency=\""+curr+"\" AND ");
   if(date == null)
    condition.append("transBankBalDate>=CURRENT_DATE;");
   else
    condition.append("transBankBalDate>=\""+date+"\";");
   db.UpdateSpecial("transBankBalance",setting.toString(),condition.toString());
   setting.delete(0,setting.length());
   condition.delete(0,condition.length());
  }
 }

 private void addToNoBankBalance(String date,String curr,String amt,
  DBConnect db) throws SQLException
 {
  Encap e = new Encap();
  int len = Mandalatama.typeCurrency.length;
  DateUtil du = null;
  if(date == null)
  {
   du = new DateUtil();
   date = du.formSQLDate();
  }
  else
   du = new DateUtil(date);
  
  DateUtil aDayBefore = new DateUtil(date);
  DateUtil aWeekAgo = new DateUtil(date);
  aDayBefore.addCalendar(1,-1);
  aWeekAgo.addCalendar(1,-7);
  String d1 = aDayBefore.formSQLDate();
  String d2 = aWeekAgo.formSQLDate();
  aDayBefore.clearCalendar();
  aWeekAgo.clearCalendar();
  du.clearCalendar();
  du = null;
  aWeekAgo = null;
  aDayBefore = null;

  Vector v1 = db.QueryMulti("transBankBalance","*",
  "WHERE transBankBalDate<=\""+d1+"\" AND "+
  "transBankBalDate>=\""+d2+"\" "+
  "ORDER BY transBankBalDate DESC LIMIT 4;");

  boolean pastExist = false;
  boolean futureExist = false;
  MultipleCurrency balance = new MultipleCurrency(Mandalatama.typeCurrency);

  if(v1 != null)
  {
   while(!v1.isEmpty())
   {
    e = (Encap)v1.remove(0);
    balance.sumAR(e.extractString("transBankBalCurrency",null),
    e.extractAll("transBankBalAmount"));
    e.clear();
   } 
   pastExist = true;
   v1 = null;
  }

  v1 = db.QueryMulti("transBankBalance","*",
  "WHERE transBankBalDate>\""+date+"\" "+
  "ORDER BY transBankBalDate DESC LIMIT 1;");
  if(v1 != null)
  {
   futureExist = true;
   v1.removeAllElements();
  }

  Vector v = new Vector(len);
  for(int i=0;i<len;i++)
  {
   e.setTable("transBankBalance");
   e.setNameVal("transBankBalDate",date);

   if(curr.equalsIgnoreCase(Mandalatama.typeCurrency[i]))
   {
    e.setNameVal("transBankBalCurrency",curr);
    if(pastExist)
    {
     balance.sumAR(curr,amt);
     e.setNameVal("transBankBalAmount",balance.getSumAR(i).toString());
    }
    else
     e.setNameVal("transBankBalAmount",amt);
    if(futureExist)
    {
     StringBuffer q = new StringBuffer(64);
     q.append("UPDATE transBankBalance SET transBankBalAmount=");
     q.append("(transBankBalAmount+"+amt+") ");
     q.append("WHERE transBankBalCurrency=\""+curr+"\" ");
     q.append("AND transBankBalDate>\""+date+"\";");
     v1.add(q.toString());
     q.delete(0,q.length());
    }
   }
   else
   {
    e.setNameVal("transBankBalCurrency",Mandalatama.typeCurrency[i]);
    e.setNameVal("transBankBalAmount",balance.getSumAR(i).toString());
   }
   v.add(e.clone());
   e.clear();
  }
  db.InsertMulti((Vector)v.clone());
  if(v1 != null)
  {
   if(!v1.isEmpty())
   {
    db.UpdateSpecialMany((Vector)v1.clone());
    v1.removeAllElements();
   }
  }

  v.removeAllElements();
  v = null;
  e = null;
 }

/**
 * processAdditional's method is to process and check whether the 
 * entries is allowed to be into database where the transaction is already
 * exist in the db. The additional entries is toward the transaction payment
 * @param Encap p - the previous existed transaction
 *        Encap c - the currenct entered transaction
 *        DBConnect db - the connection to database
 * @return none
 */
 private boolean processAdditional(Encap p,Encap c,DBConnect db)
	throws SQLException
 {
  int pos = c.getPosition("invDate");
  Vector v = new Vector(2);
  Encap r = new Encap("transPayment");
  r.setNameVal("transPaymentMethod",c.extractAll("method"));
  r.setNameVal("transPaymentType",c.extractString("type",null));
  r.setNameVal("transPaymentCurr",c.extractAll("currency"));
  r.setNameVal("transPaymentAmnt",c.extractAll("invAmount"));
  r.setNameVal("transPaymentOfKey",p.extractInteger("transKey",0));
  if(pos < 0)
   r.setNameVal("transPaymentDate","CURRENT_DATE");
  else
  {
   r.setNameVal("transPaymentDate",VariousCheck.formDate(
    c.getValue(pos)));
   date = c.getValue(pos);
  }
  r.setNameVal("transPaymentTime","CURRENT_TIME");
  r.setCondition("SET @paymentKey = LAST_INSERT_ID();");
  v.add((Encap)r.clone());
  r.clear();
  pos = c.getPosition("invRemarks");
  if(pos>=0)
  {
   r.setTable("transRemarks");
   r.setNameVal("transRemarksContent",c.getStringValue(pos));
   r.setNameVal("transRemarksOfKey","@paymentKey");
   v.add((Encap)r.clone());
   r.clear();
  }
  pos = c.getPosition("invNoDoc");
  if(pos>=0)
  {
   r.setTable("transDocument");
   r.setNameVal("transDocOfKey","@paymentKey");
   r.setNameVal("transDocNo",c.getStringValue(pos));
   v.add((Encap)r.clone());
   r.clear();
  }
  db.InsertMulti((Vector)v.clone());
  v.removeAllElements();
  return true;
 }

/**
 * processNormal's method is to process a normal entry into the database
 * whether it is paid or not paid. it setups up the entry to database
 * @param Encap en - contains the data to be enter
 *        DBConnect db - contains connection to database
 * @return true if all successful else false
 */
 private boolean processNormal(Encap en,DBConnect db) throws SQLException
 {
  if(en == null)
  {
   error.append("Received a null package\n");
   return false;
  }
  Vector v = new Vector(3);
  int pos = 0;

  Encap en2 = new Encap("transaction");
  if(en.getPosition("invNo")>=0)
   en2.setNameVal("transInvoiceNo",Integer.parseInt(en.extractAll("invNo")));
  en2.setNameVal("transDescription",en.extractString("invDesc",null));
	pos = en.getPosition("invDate");
  if(pos < 0)
   en2.setNameVal("transDate","CURRENT_DATE");
  else
  {
   en2.setNameVal("transDate",VariousCheck.formDate(en.getValue(pos)));
   date = en.getValue(pos);
  }
  en2.setNameVal("transTime","CURRENT_TIME");
  en2.setVariable("SET @transKey=LAST_INSERT_ID();");
  v.add(en2.clone());
  en2.clear();
  en2.setTable("transPayment");
  en2.setNameVal("transPaymentMethod",en.extractAll("method"));
  en2.setNameVal("transPaymentType",en.extractString("type",null));
  en2.setNameVal("transPaymentCurr",en.extractAll("currency"));
  en2.setNameVal("transPaymentAmnt",en.extractAll("invAmount"));
  en2.setNameVal("transPaymentOfKey","@transKey");
  if(pos < 0)
   en2.setNameVal("transPaymentDate","CURRENT_DATE");
  else
   en2.setNameVal("transPaymentDate",VariousCheck.formDate(en.getValue(pos)));
  en2.setNameVal("transPaymentTime","CURRENT_TIME");
  en2.setVariable("SET @paymentKey=LAST_INSERT_ID();");
  v.add(en2.clone());
  en2.clear();
  if(!VariousCheck.checkException(en.extractAll("method")))
  {
   en2.setTable("transDocument");
   en2.setNameVal("transDocOfKey","@paymentKey");
   en2.setNameVal("transDocNo",en.extractAll("invNoDoc"));
   v.add(en2.clone());
   en2.clear();
  }
  pos = en.getPosition("invRemarks");
  if(pos>=0)
  {
   en2.setTable("transRemarks");
   en2.setNameVal("transRemarksContent",en.extractAll("invRemarks"));
   en2.setNameVal("transRemarksOfKey","@paymentKey");
   v.add(en2.clone());
   en2.clear();
  }
  db.InsertMulti((Vector)v.clone());
  v.removeAllElements();
  return true;
 }

}
