import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.util.StringTokenizer;
import java.sql.SQLException;

public class Mandalatama extends JFrame
{
 public final static int EDITINV = 1; //EDIT BY INVOICE

 public Dimension prefDimension = new Dimension();

 private JTextField invNoTx;
 private JTextField invDateTx; // optional date
 private JTextField invDescTx; // must filled
 private JTextField invNoDocTx; // must filled if credit/debit/cheque/giro
 private JTextField invAmountTx; // must filled
 private JTextField invRemarksTx;

 private JComboBox invTypeRecord;
 private JComboBox invTypeMethod;
 private JComboBox invTypeCurrency;

 private JButton submitButton;
 private JButton resetButton;
 private JButton closeButton;

 private JMenuItem mAddUSR; // Add USER
 private JMenuItem mRemUSR; // Remove User
 private JMenuItem mVwUSR;  // View User
 private JMenuItem mAddRM;  // Add Remarks
 private JMenuItem mEdit;   // Edit
 private JMenuItem mAudit;  // Audit
 private JMenuItem mVBIN;   // View By Invoice No
 private JMenuItem mVBK;    // View By Key
 private JMenuItem mVBSD;   // View By Single Date
 private JMenuItem mVBMD;   // View By Multiple Date

 private JMenuItem mPrintReport;

 private Encap masterEn = new Encap();
 private StringBuffer error = new StringBuffer(56);

 public static String[] typeRecord = {"DEBIT","CREDIT"};
 public static String[] typeMethod = {"CASH","DEBIT CARD","CREDIT CARD",
 "BCA CARD","GIRO","CHEQUE","TRANSFER"};
 public static String[] typeCurrency = {"IDR","USD","HKD","SGD"};

 public static final int AUDIT = 1; // AUDIT
 public static final int ADDRM = 2; // ADD NEW REMARKS
 public static final int EDIT  = 3; // EDIT 
 public static final int VSD   = 4; // VIEW SINGLE DATE 
 public static final int VMD   = 5; // VIEW MULTI DATE
 public static final int VTK   = 6; // VIEW TRANS KEY 
 public static final int VTI   = 7; // VIEW TRANS INVOICE
 public static final int REMUSR = 8; // REMOVE USER
 public static final int ADDUSR = 9; // ADD USER
 public static final int PSD    = 10; // PRINT SINGLE DATE

 public Mandalatama()
 {
  super("PT. Mandalatama Tours and Travel CASH Book");
  initialize();
  setJMenuBar(createMenuBar());
  getContentPane().add(new JScrollPane(createMain()));
 }

 public JPanel createMain()
 {
  JPanel panel = new JPanel();
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.CENTER;
  gbc.fill = GridBagConstraints.BOTH;
  gbc.gridx = GridBagConstraints.RELATIVE;
  gbc.insets = new Insets(2,2,2,2);
  panel.setLayout(gbl);
  gbc.gridy = 0;
  panel.add(createPanel(),gbc);
  gbc.gridy++;
  panel.add(createBottom(),gbc);
  return panel;
 }

 public JPanel createPanel()
 {
  JPanel panel = new JPanel();
  panel.setBorder(new TitledBorder(new LineBorder(Color.black,1),
  "CASHIER BOOK"));
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.NORTHWEST;
  gbc.fill = GridBagConstraints.HORIZONTAL;
  gbc.gridx = GridBagConstraints.RELATIVE;
  gbc.insets = new Insets(2,2,2,2);
  gbc.gridwidth = 3;
  panel.setLayout(gbl);
  gbc.gridy = 0;
	panel.add(new JLabel("Invoice Date",SwingConstants.RIGHT),gbc);
	panel.add(new createTextField(invDateTx,10),gbc);
	panel.add(new JLabel("(Optional) DD-MM-YYYY",SwingConstants.LEFT),gbc);
	gbc.gridy++;
  panel.add(new JLabel("Invoice No",SwingConstants.RIGHT),gbc);
  panel.add(new createTextField(invNoTx,10),gbc);
  panel.add(new JLabel("(Optional)",SwingConstants.LEFT),gbc);
  gbc.gridy++;
  panel.add(new JLabel("Invoice Description",SwingConstants.RIGHT),gbc);
  panel.add(new createTextField(invDescTx,32),gbc);
  panel.add(new JLabel("Ex: Setor BCA, Mr. Fuad, "+
  "Refund Mr.Fuad",SwingConstants.LEFT),gbc);
  gbc.gridy++;
  panel.add(new JLabel("Type of Transaction",SwingConstants.RIGHT),gbc);
  panel.add(new createComboBox(invTypeRecord,false),gbc);
  gbc.gridy++;
  panel.add(new JLabel("Payment Method",SwingConstants.RIGHT),gbc);
  panel.add(new createComboBox(invTypeMethod,false),gbc);
  gbc.gridy++;
  panel.add(new JLabel("Payment Document No.",SwingConstants.RIGHT),gbc);
  panel.add(new createTextField(invNoDocTx,24),gbc);
  panel.add(new JLabel("Only Giro/Cheque/BCA/Credit/Debit Card No.",
  SwingConstants.LEFT),gbc);
  gbc.gridy++;
  panel.add(new JLabel("Payment Remarks",SwingConstants.RIGHT),gbc);
  panel.add(new createTextField(invRemarksTx,128),gbc);
  panel.add(new JLabel("(Optional) Max 128 Characters",
	SwingConstants.LEFT),gbc);
  gbc.gridy++;
  panel.add(new JLabel("Payment Amount",SwingConstants.RIGHT),gbc);
  panel.add(new createComboBox(invTypeCurrency,false),gbc);
  panel.add(new createTextField(invAmountTx,15),gbc);
  return panel;
 }

 public JPanel createBottom()
 {
  JPanel panel = new JPanel(new FlowLayout());
  panel.add(submitButton);
  panel.add(resetButton);
  panel.add(closeButton);
  return panel;
 }

 private void collectText()
 {
  if(invNoTx.getText().length()>=1)
   insertMaster("invNo",invNoTx.getText());
  if(invDateTx.getText().length()>=1)
   insertMaster("invDate",invDateTx.getText());
  if(invDescTx.getText().length()>=1)
   insertMaster("invDesc",invDescTx.getText());
  if(invNoDocTx.getText().length()>=1)
   insertMaster("invNoDoc",invNoDocTx.getText());
  if(invRemarksTx.getText().length()>=1)
   insertMaster("invRemarks",invRemarksTx.getText());
  if(invAmountTx.getText().length()>=1)
   insertMaster("invAmount",invAmountTx.getText());
 }

 private boolean checkCollect()
 {
  boolean failedFlag = false; // assume not fail
  int pos = masterEn.getPosition("invNo");
  if(pos >= 0 &&
   !VariousCheck.checkInt(masterEn.getStringValue(pos),1))
  {
   error.append("Invoice No must be in digit form only\n");
   failedFlag = true;
  }
  pos = masterEn.getPosition("invDate");
  if(pos >= 0) // if exist check validity
  {
   if(!DateUtil.verifyNormalDate(masterEn.getValue(pos)))
    error.append("Invalid date format! Enter DD-MM-YYYY\n"+
    "For example: 31-12-2003\n");
  }
  pos = masterEn.getPosition("invDesc");
  if(pos < 0)
  {
   error.append("Invoice Description must be filled\n");
   failedFlag = true;
  }
  if(!VariousCheck.checkException(masterEn.extractAll("method")))
  {
   pos = masterEn.getPosition("invNoDoc");
   if(pos < 0 && !masterEn.extractAll("method").equalsIgnoreCase("TRANSFER"))
   {
    error.append("You must fill Payment Document No\n");
    failedFlag = true;
   }
  }
  pos = masterEn.getPosition("invAmount");
  if(pos < 0)
  {
   error.append("You must fill Payment Amount\n");
   failedFlag = true;
  }
  else
  {
   if(!VariousCheck.checkInt(masterEn.getStringValue(pos),3))
   {
    error.append("Invoice Amount has non-digit input in it\n");
    failedFlag = true;
   }
  }
  return failedFlag;
 }

 private void insertMaster(String name,String val)
 {
  int pos = masterEn.getPosition(name);
  if(pos>=0) masterEn.removeNameVal(pos);
  masterEn.setNameVal(name,val);
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   System.out.println("====== actionPerformed ======");
   JButton jb = (JButton)e.getSource();
   if(jb == submitButton)
   {
    collectText();
    if(checkCollect())
    {
     errorDisplay(error.toString(),"ERROR");
     error.delete(0,error.length());
    }
    else
    {
     new Commit(masterEn);
     reset();
    } 
   }
   else if(jb == closeButton)
    close();
   else // must be reset
    reset();
   System.out.println("====== exit actionPerformed =");
  }
 }

 private void close()
 {
  System.gc();
  System.exit(0);
 }

 private class ComboListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JComboBox jc = (JComboBox)e.getSource();
   String source = (String)jc.getSelectedItem();
   int pos = 0;
   if(jc == invTypeCurrency)
    insertMaster("currency",source);
   else if(jc == invTypeMethod)
    insertMaster("method",source);
   else if(jc == invTypeRecord)
    insertMaster("type",source);
  }
 }

 private class createComboBox extends JPanel
 {
  public createComboBox(JComboBox choice,boolean edit)
  {
   setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
   choice.setEditable(edit);
   choice.setFont(new Font("SansSerif",Font.BOLD,12));
   choice.setAlignmentX(LEFT_ALIGNMENT);
   choice.addActionListener(new ComboListener());
   choice.setSelectedIndex(0);
   add(choice);
  }
 }

 private class createTextField extends JPanel
 {
  public createTextField(JTextField text,int limit)
  {
   setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
   text.setHorizontalAlignment(SwingConstants.LEFT);
   text.setDocument(new JTextFieldLimit(limit));
   text.getDocument().addDocumentListener(new DocumentListen());
   add(text);
  }
 }

 private class JTextFieldLimit extends PlainDocument
 {
  private int limit;
  private boolean toUpper = false;
  public JTextFieldLimit(int limit)
  {
   super();
   this.limit = limit;
  }
  public JTextFieldLimit(int limit,boolean upper)
  {
   this(limit);
   toUpper = upper;
  }
  public void insertString(int offset,String str,AttributeSet attr)
   throws BadLocationException
  {
   if(str == null) return;
   if((getLength()+str.length())<=limit)
   {
    if(toUpper) str = str.toUpperCase();
    super.insertString(offset,str,attr);
   }
  }
 }

 private class DocumentListen implements DocumentListener
 {
  public void changedUpdate(DocumentEvent de)
  {
   try { }
   catch(Exception e) { }
  }
  public void insertUpdate(DocumentEvent de)
  {
   try { }
   catch(Exception e) { }
  }
  public void removeUpdate(DocumentEvent de)
  {
   try { }
   catch(Exception e) { }
  }
 }

 protected JMenuBar createMenuBar()
 {
  JMenuBar menuBar = new JMenuBar();
  JMenu mFile = new JMenu("File");
  JMenuItem mExit = new JMenuItem("Exit");
  mExit.setMnemonic('x');
  mExit.addActionListener(new ActionListener()
  {
   public void actionPerformed(ActionEvent e)
   { System.exit(0); }
  });

  JMenu mData = new JMenu("Data");
  JMenu mAdd = new JMenu("Add"); 
  JMenu mUser = new JMenu("User");

  mAddUSR = new JMenuItem("Add");
  mRemUSR = new JMenuItem("Modify/Remove");
  mVwUSR = new JMenuItem("View");
  mUser.add(mAddUSR);
  mUser.add(mRemUSR);
  mUser.add(mVwUSR);

  mEdit = new JMenuItem("Edit");
  mAudit= new JMenuItem("Audit");
  mAddRM = new JMenuItem("Remarks");

  mAdd.add(mAddRM);
  mData.add(mAdd);
  mData.add(mAudit);
  mData.add(mEdit);

  JMenu mPrint = new JMenu("Print");
  mPrintReport = new JMenuItem("Report By Date");
  mPrint.add(mPrintReport);
  mFile.add(mUser);
  mFile.add(mPrint);
  mFile.add(mExit);

  JMenu mView = new JMenu("View");
  mVBMD = new JMenuItem("By Start-End Date");
  mVBSD = new JMenuItem("By Single Date");
  mVBK  = new JMenuItem("By Transaction Key");
  mVBIN = new JMenuItem("By Invoice No");
  mView.add(mVBIN);
  mView.add(mVBK);
  mView.add(mVBSD);
  mView.add(mVBMD);
  mData.add(mView);

  MenuItemListener mil = new MenuItemListener();
  mPrintReport.addActionListener(mil);
  mAddRM.addActionListener(mil);
  mAudit.addActionListener(mil);
  mEdit.addActionListener(mil);
  mVBIN.addActionListener(mil);
  mVBK.addActionListener(mil);
  mVBMD.addActionListener(mil);
  mVBSD.addActionListener(mil);
  mAddUSR.addActionListener(mil);
  mRemUSR.addActionListener(mil);
  mVwUSR.addActionListener(mil);
  menuBar.add(mFile);
  menuBar.add(mData);
  return menuBar;
 }

 public class MenuItemListener implements ActionListener
 {
  StringBuffer msg = new StringBuffer(56);
  private int flag = 0;
  public void actionPerformed(ActionEvent e)
  {
   JMenuItem jmi = (JMenuItem)e.getSource();
   if(jmi == mVBMD)
   {
    System.out.println("View By MultipleDate");
    msg.append("Enter A Pair of From and To Date\n");
    msg.append("DD-MM-YYYY(i.e: 1-1-2003,31-1-2003)\n");
    flag = Mandalatama.VMD;
   }
   else if(jmi == mVBSD)
   {
    System.out.println("View By SingleDate");
    msg.append("Enter A Single Date\n");
    msg.append("DD-MM-YYYY(i.e: 31-1-2003)\n");
    flag = Mandalatama.VSD;
   }
   else if(jmi == mVBK)
   {
    System.out.println("View By Transaction Key");
    msg.append("Enter A Transaction Key\n");
    msg.append("(i.e: 140)\n");
    flag = Mandalatama.VTK;
   }
   else if(jmi == mVBIN)
   {
    System.out.println("View By Invoice No");
    msg.append("Enter An Invoice No\n");
    msg.append("(i.e: 101)\n");
    flag = Mandalatama.VTI;
   }
   else if(jmi == mAddRM)
   {
    System.out.println("Add Remarks");
    msg.append("Enter Transaction Key\n");
    msg.append("(i.e: 130)\n");
    flag = Mandalatama.VTK;
   }
   else if(jmi == mAudit)
   {
    System.out.println("Audit");
    msg.append("Enter A Single Date\n");
    msg.append("DD-MM-YYYY(i.e: 31-1-2003)\n");
    flag = Mandalatama.AUDIT;
   }
   else if(jmi == mEdit)
   {
    System.out.println("Edit");
    msg.append("Enter Transaction Key\n");
    msg.append("(i.e: 100)\n");
    flag = Mandalatama.EDIT;
   }
   else if(jmi == mPrintReport)
   {
    System.out.println("Print Report");
    msg.append("Enter A Single Date\n");
    msg.append("DD-MM-YYYY (i.e: 31-1-2003)\n");
    flag = Mandalatama.PSD;
   }
   else if(jmi == mVwUSR)
   {
    new ViewUser();
    return;
   }
   else if(jmi == mAddUSR)
   {
    new PasswordChecker(Mandalatama.ADDUSR,1,"Enter username and password",
    null);
    return;
   }
   else if(jmi == mRemUSR)
   {
    new PasswordChecker(Mandalatama.REMUSR,2,"Enter username and password",
    null);
    return;
   }
   processEntry(flag,msg.toString());
   msg.delete(0,msg.length());
  }

  private void processEntry(int cflag, String head)
  {
   boolean flag = false;
   do
   {
    String entry = Mandalatama.questionDisplay(head,"Question");
    if(entry == null) return;
    switch(cflag)
    {
     case Mandalatama.AUDIT : flag = processAudit(entry); break;
     case Mandalatama.ADDRM : flag = processRemarks(entry); break;
     case Mandalatama.EDIT  : flag = processEdit(entry); break;
     case Mandalatama.VSD   : flag = processSingleDate(entry); break;
     case Mandalatama.VMD   : flag = processMultiDate(entry); break;
     case Mandalatama.VTK   : flag = processTransKey(entry); break;
     case Mandalatama.VTI   : flag = processInvoice(entry); break;
     case Mandalatama.PSD   : flag = processPrint(cflag,entry); break;
    }
   }while(!flag);
  }

  private boolean processMultiDate(String s)
  {
   boolean success = true;
   String date1 = null;
   String date2 = null;
   if(s.indexOf(',')<0)
   {
    Mandalatama.errorDisplay("You must enter a pair of Date (FROM,TO)\n"+
    "Separate the dates with Comma.\n(i.e: 2003-1-1,2003-1-31)\n","ERROR");
    success = false; 
   }
   else
   {
    StringTokenizer stk = new StringTokenizer(s,",");
    date1 = stk.nextToken();
    date2 = stk.nextToken(); 
    if(!VariousCheck.checkDate(date1))
     success = false;
    if(!VariousCheck.checkDate(date2))
     success = false;
    if(success)
    {
     int stat = VariousCheck.compareDate(date1,date2);
     if(stat>=0)
      success = false;
    }
   }
   if(success)
    new ViewByMultiDate(VariousCheck.formDate(date1),
     VariousCheck.formDate(date2));
   else
    Mandalatama.errorDisplay("You must enter the correct date format.\n"+
    "(i.e: 31-1-2003) [DD-MM-YYYY]\nYou have entered: "+s,"ERROR"); 
   return success;
  }

  private boolean processSingleDate(String s)
  {
   boolean success =  VariousCheck.checkDate(s);
   if(success)
    new ViewBySingleDate(VariousCheck.formDate(s));
   else
    Mandalatama.errorDisplay("You must enter the correct date format.\n"+
    "(i.e: 31-12-2003) [DD-MM-YYYY]\nYou have entered: "+s,"ERROR");
   return success;
  }

  private boolean processTransKey(String s)
  {
   boolean success = VariousCheck.checkInt(s,1);
   if(success)
    new ViewByTransKey(Integer.parseInt(s));
   else
   {
    Mandalatama.errorDisplay("You must enter digit\n(i.e: 12)\n","ERROR");
    success = false;
   }
   return success;
  }

  private boolean processInvoice(String s)
  {
   boolean success = VariousCheck.checkInt(s,1);
   if(success)
    new ViewByTransInvoice(s);
   else
    Mandalatama.errorDisplay("You must enter digit\n(i.e: 12)\n","ERROR");
   return success;
  }
  
  private boolean processRemarks(String s)
  {
   boolean success = VariousCheck.checkInt(s,1);
   if(success)
    new ProcessAdd(0,ADDRM,s);
   else
    Mandalatama.errorDisplay("You must enter digit\n(i.e: 12)\n","ERROR");
   return success;
  }

  private boolean processAudit(String s)
  {
   boolean success = VariousCheck.checkDate(s);
   if(success)
    new PasswordChecker(Mandalatama.AUDIT,3,"Enter username and password",
     VariousCheck.formDate(s));
   else
    Mandalatama.errorDisplay("You must enter the correct date format.\n"+
    "(i.e: 31-12-2003) [DD-MM-YYYY]\n","ERROR");
   return success;
  }

  private boolean processEdit(String s)
  {
   boolean success = VariousCheck.checkInt(s,1);
   if(success)
    new PasswordChecker(Mandalatama.EDIT,3,"Enter username and password",s);
   else
    Mandalatama.errorDisplay("You must enter digit\n(i.e: 12)\n","ERROR");
   return success;
  }

  private boolean processPrint(int flag,String s)
  {
   boolean success = true;
   if(flag == Mandalatama.PSD)
    success = VariousCheck.checkDate(s);
   if(success)
    new ProcessPrintReport(flag,s);
   else
    Mandalatama.errorDisplay("You must enter the correct date format.\n"+
    "(i.e: 31-1-2003) [DD-MM-YYYY]\nYou have entered: "+s,"ERROR");
   return success;
  }
 }

 private void initialize()
 {
  initJText();
  initJButton();
  initJCombo();
 }

 private void reset()
 {
  masterEn.clear();
  clearJText();
  resetJCombo();
 }

 private void clearJText()
 {
  invDescTx.setText("");
  invDateTx.setText("");
  invNoTx.setText("");
  invNoDocTx.setText("");
  invAmountTx.setText("");
  invRemarksTx.setText("");
 }

 private void resetJCombo()
 {
  invTypeRecord.setSelectedIndex(0);
  invTypeMethod.setSelectedIndex(0);
  invTypeCurrency.setSelectedIndex(0);
 }

 private void initJText()
 {
  invNoTx = new JTextField(10);
  invDateTx = new JTextField(10);
  invDescTx = new JTextField(10);
  invNoDocTx = new JTextField(10);
  invAmountTx = new JTextField(10);
  invRemarksTx = new JTextField(10);
 }

 private void initJCombo()
 {
  invTypeRecord = new JComboBox(typeRecord);
  invTypeMethod = new JComboBox(typeMethod);
  invTypeCurrency = new JComboBox(typeCurrency);
 }

 private void initJButton()
 {
  submitButton = new JButton("Submit");
  resetButton = new JButton("Reset");
  closeButton = new JButton("Close");
  ButtonListener listener = new ButtonListener();
  submitButton.addActionListener(listener);
  resetButton.addActionListener(listener);
  closeButton.addActionListener(listener);
 }

 public static void errorDisplay(String str,String title)
 {
  JOptionPane.showMessageDialog(null,str,title,JOptionPane.ERROR_MESSAGE);
  return;
 }

 public static void infoDisplay(String str,String title)
 {
  JOptionPane.showMessageDialog(null,str,title,JOptionPane.INFORMATION_MESSAGE);
  return;
 }

 public static String questionDisplay(String str,String title)
 {
  return (String)JOptionPane.showInputDialog(null,str,title,
  JOptionPane.QUESTION_MESSAGE);
 }

 public Dimension getPreferredSize()
 { 
  return prefDimension;
 }

 public void setPreferredSize(Dimension dim)
 {
  prefDimension.setSize(640.0,350.0);
 }

 public static void main(String argv[])
 {
  Mandalatama mnd = new Mandalatama();
  mnd.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mnd.setPreferredSize(mnd.getToolkit().getScreenSize());
  mnd.pack();
  mnd.setVisible(true);
 }
}
