import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import java.sql.SQLException;

public class PasswordChecker
{
 private JFrame frame;
 private JPasswordField password;
 private int limit = 32;
 private int uID = 0;
 private int level;
 private String title;
 private int usrLvl = 0;
 private boolean flag;
 private int usrID = 0;
 private JTextField username;
 private String usrname = null;
 private String content;
 private JButton contButton;
 private JButton cancButton;
 private int destination = 0;
 private Encap en = null;

 public PasswordChecker(int dest,int lvl,String ftitle,String con)
 {
  destination = dest;
  content = con;
  level = lvl;
  frame = new JFrame(ftitle);
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(),BorderLayout.CENTER);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Mandalatama.infoDisplay("Click on Cancel in the panel instead",
     "Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel(new GridLayout(2,2));
  username = new JTextField(10);
  password = new JPasswordField(10);
  password.setEchoChar('#');
  username.setDocument(new JTextFieldLimit(limit));
  username.getDocument().addDocumentListener(new DocumentListen());
  panel.add(new JLabel("Authorized Username:"));
  panel.add(username);
  panel.add(new JLabel("Authorized Password:"));
  panel.add(password);
  return panel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel(new FlowLayout());
  contButton = new JButton("Continue");
  cancButton = new JButton("Cancel");
  ButtonListener listener = new ButtonListener();
  contButton.addActionListener(listener);
  cancButton.addActionListener(listener);
  panel.add(contButton);
  panel.add(cancButton);
  return panel;
 }

 private class ButtonListener implements ActionListener
 {
  StringBuffer error = new StringBuffer();
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == contButton)
   {
    String p = new String(password.getPassword());
    if(p.length()>16 || p.length()<6)
      error.append("Password must be between 6 to 16 characters\n");
    if(username.getText().length()<1)
     error.append("You must fill the username\n");
    if(error.length()==0)	
    {
     if(checkPassword(username.getText(),p))
     {
      if(error.length()==0)
      {
       switch(destination)
       {
        case Mandalatama.AUDIT : new ProcessAudit(content,uID); break;
	      case Mandalatama.ADDUSR : new ProcessUser(destination,uID); break;
	      case Mandalatama.REMUSR : new ProcessUser(destination,uID); break;
	      case Mandalatama.EDIT : new ProcessEdit(content,uID); break;
        default:	
       }
       close();
      }
     }
     else
     {
      System.out.println("It is actually false");
     }
    }
    if(error.length()>0) 
    {
     Mandalatama.errorDisplay(error.toString(),"ERROR");
     error.delete(0,error.length());
    }
   }
   else
    close();
   return;
  }

  private void close()
  {
   frame.dispose();
   System.gc();
  }

  private boolean checkPassword(String name,String pass)
  {
   DBConnect db = new DBConnect();
   if(!db.makeConnection("MANDALATAMA"))
   {
    error.append("Failure to make connection to database LKB");
    return false;
   }
   try
   {
    StringBuffer msg = new StringBuffer("WHERE authorizedName=\"");
    msg.append(name+"\" AND authorizedPassKey=PASSWORD(\'");
    msg.append(pass+"\');");
    Encap en = db.QuerySingle("authorizedUser","*",msg.toString());
    if(en == null)
     error.append("No such username exist or you have enter wrong password");
    else
    {
     uID = en.extractInteger("authorizedID",0);
     if(en.extractString("authorizedValid",null).compareToIgnoreCase("Y")!=0)
      error.append("The username that you used is no longer valid\n");
     else
     {
      usrLvl = en.extractInteger("authorizedLevel",0);
      if(usrLvl>level)
       error.append("Your authorized level is not enough");
      else
       usrID=en.extractInteger("authorizedKey",0);
     }
    }
   }
   catch(SQLException sqle)
   {
    sqle.printStackTrace(System.out);
    error.append(sqle.toString());
   }
   if(error.length()>0)
    return false; 
   return true;
  }

  private void displayError(String msg,String title)
  {
   JOptionPane.showMessageDialog(frame,msg,title,
    JOptionPane.ERROR_MESSAGE);
  }
 }

 private void reset()
 {
  en.clear();
 }

 private class DocumentListen implements DocumentListener
 {
  public void changedUpdate(DocumentEvent de)
  { try { } catch(Exception e) { } }
  public void insertUpdate(DocumentEvent de)
  { try { } catch(Exception e) { } }
  public void removeUpdate(DocumentEvent de)
  { try { } catch(Exception e) { } }
 }

 private class JTextFieldLimit extends PlainDocument
 {
  private int limit;
  public JTextFieldLimit(int lim)
  {
   super();
   limit = lim;
  }
  public void insertString(int offset,String str,AttributeSet attr)
   throws BadLocationException
  {
   if(str == null) return;
   if((getLength()+str.length())<=limit)
   super.insertString(offset,str,attr);
  }
 }
}
