import java.util.Vector;
import java.util.StringTokenizer;
import java.sql.SQLException;

public class ProcessAdd
{
 StringBuffer error = new StringBuffer(56);

 public ProcessAdd(int uid,int flag, String s)
 { 
  System.out.println("ProcessAdd -- start ");
  if(s == null)
  {
   Mandalatama.errorDisplay("Received invalid input","ERROR");
   return;
  }
  if(flag != Mandalatama.ADDRM)
  {
   Mandalatama.errorDisplay("No action available for: "+flag,"ERROR");
   return;
  }
  DBConnect db = new DBConnect(); 
  try
  {
   if(!db.makeConnection("MANDALATAMA"))
    throw new SQLException("Failure to make connection to database\n");
   processNewRemarks(Integer.parseInt(s),db);
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   Mandalatama.errorDisplay(sqle.getMessage(),"ERROR");
  }
  finally
  {
   if(error.length()>0) 
   {
    Mandalatama.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
   }
   db.close();
   db = null;
  }
  System.out.println("ProcessAdd -- end ");
 }

 private void processNewRemarks(int tKey,DBConnect db)
  throws SQLException
 {
  Encap e = db.QuerySingle("transDocument","*",
		"WHERE transDocOfKey="+tKey+";");
  if(e == null)
  {
   error.append("No Document of such Transaction Key found");
   return;
  }
  e.clear();
  boolean success = false;
  do
  {
   String s = Mandalatama.questionDisplay("Enter the new remark "+
	 "(max 128 characters)","Question");
   if(s != null && s.length()<=128)
   {
    e.setTable("transDocument");
    e.setCondition("WHERE transDocOfKey="+tKey+";");
    e.setNameVal("transDocNo",s);
    db.UpdateData((Encap)e.clone());
    e.clear();
    success = true;
   }
   else if(s != null && s.length()>128)
   {
    Mandalatama.errorDisplay("You may only type up to 128 "+
		"characters for remarks","ERROR");
   }
   else if(s == null) return;
  } while(!success);

  return;
 }

}
