import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.sql.SQLException;
import java.util.Vector;

public class ProcessAudit
{

 private JFrame frame;
 private JTable table;
 private tableData td;
 private JButton auditButton;
 private JButton closeButton;
 private JButton skipNextButton;
 private JButton skipPrevButton;
 private StringBuffer error = new StringBuffer(56);
 private Vector result = null;
 private Vector sresult = null;
 private int usrID = 0;
 private String date = null;
 private DBConnect db = new DBConnect();
 private int sequence = 0;
 private int[] keys = null;
 private int[] ids = {0,0,0};

 public ProcessAudit(String s,int uID)
 { 
  if(s == null) 
  {
   Mandalatama.errorDisplay("Received Invalid Date Input","ERROR");
   return;
  }
  usrID = uID;
  date = new String(s);
	System.out.println ("date: "+date);
  getData();
  if(error.length()>0)
  {
   Mandalatama.errorDisplay(error.toString(),"ERROR");
   return;
  }
  frame = new JFrame("Audit for date: "+VariousCheck.formNDate(s));
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(),BorderLayout.CENTER);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Mandalatama.infoDisplay("Click on Close in the panel instead",
    "Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel(new BorderLayout());
  td = new tableData(sresult);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setModel(td);
  table.setRowHeight(20);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  for(int i=0;i<td.colLength;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   if(i==td.TKEY||i==td.TINV||i==td.TTYP||i==td.TMTD||i==td.TCUR)  
    column = new TableColumn(i,8,render,editor);
   else
    column = new TableColumn(i,20,render,editor);
   column.setHeaderRenderer(mlhr);
   table.addColumn(column);
  }
  JList head = new JList(new ListMod(sresult.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.setPreferredSize(new Dimension(600,100));
  panel.add(jsp,BorderLayout.CENTER);
  return panel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel(new FlowLayout());
  auditButton = new JButton("Ok");
  closeButton = new JButton("Close");
  skipNextButton = new JButton("Skip Next");
  skipPrevButton = new JButton("Skip Prev");
  panel.add(skipPrevButton);
  panel.add(auditButton);
  panel.add(skipNextButton);
  panel.add(closeButton);

  ButtonListener bl = new ButtonListener();
  auditButton.addActionListener(bl);
  closeButton.addActionListener(bl);
  skipNextButton.addActionListener(bl);
  skipPrevButton.addActionListener(bl);
  panel.setPreferredSize(new Dimension(600,50));
  return panel;
 }

 public void getData()
 {
  try
  {
   if(!db.makeConnection("MANDALATAMA"))
    throw new SQLException("Failure to make connection");
   processData(db.QueryMulti("transPayment","*",
	 "LEFT JOIN transaction ON (transPayment.transPaymentOfKey="+
	 "transaction.transKey) "+"WHERE transPaymentDate=\""+date+"\";"),db);
  }
  catch(SQLException sqle)
  {
   error.append(sqle.getMessage());
   sqle.printStackTrace();
  }

 }

 private void processData(Vector v,DBConnect db) throws SQLException
 {
  if(v == null)
  {
   error.append("No transaction available for date: "+date+"\n");
   return;
  }
  Encap e = null;
  Encap e2= null;
  int size = 0;
	int count = 0;
	boolean found = false;
	Vector v2 = db.QueryMulti("transAudit","*",
	"WHERE transAuditByID<> \""+usrID+"\" AND transAuditDate=\""+
	date+"\""+" ORDER BY transAuditOfKey;");
	if(v2 != null)
	{
	 System.out.println("not empty");
	 int id = 0;
	 ids[0] = 0; ids[1] = 0; ids[2] = 0;
   while(!v2.isEmpty())
	 {
    e = (Encap)v2.remove(0);
		DBConnect.viewEncap(e);
    id = e.extractInteger("transAuditByID",0);
		found = VariousCheck.checkExist(ids,id);
		if(!found)
		 ids[VariousCheck.getZero(ids)] = id;
		else found = false;
		e.clear();
	 }
   for(int p=0;p<3;p++)
	  System.out.println("id: "+ids[p]);
	 if(count >= 3)
	 {
    error.append("Only 3 Auditors allow for one day audit\n");
		return;
	 }
  }
 
  size = v.size();
  keys = new int[size];
  result = new Vector(size);
  sresult = new Vector(9);
  count = 0;
  while(!v.isEmpty())
  {
   e = (Encap)v.remove(0);
   Data data = new Data();
   keys[count] = e.extractInteger("transPaymentKey",0);
   data.setTransKey(e.extractInteger("transKey",0));
   data.setTransDesc(e.extractAll("transDescription"));
   data.setTransInvNo(e.extractInteger("transInvoiceNo",0));
   data.setTransType(e.extractAll("transPaymentType"));
   data.setTransMethod(e.extractAll("transPaymentMethod"));
   data.setTransCurr(e.extractAll("transPaymentCurr"));
   data.setTransAmt(VariousCheck.formNumDelimiter(
			e.extractAll("transPaymentAmnt")));

	 if(!VariousCheck.checkException(data.getTransMethod()))
	 {
	  e2 = db.QuerySingle("transDocument","*",
		 "WHERE transDocOfKey="+data.getTransKey()+";"); 
		if(e2!=null)
		{
     data.setTransDocNo(e2.extractAll("transDocNo"));
		 e2.clear();
		}
   }

	 e2 = db.QuerySingle("transRemarks","*","WHERE transRemarksOfKey="+
		e.extractAll("transKey")+";");
	 if(e2 != null)
	 {
    data.setTransRemarks(e.extractAll("transRemarksContent"));
		e2.clear();
   }

   result.add(data);
   e.clear();
   count+=1;
  }
  sresult.add(result.get(0));
  sequence = 0;
 }

 public void close()
 {
  frame.dispose();
  if(result!=null) result.removeAllElements();
  if(sresult!=null) sresult.removeAllElements();
  result = null;
  sresult = null;
  if(db != null) db.close();
  db = null;
  System.gc();
 }

 private void processAudit(int seq)
 {
  boolean done = false;
  int tk = 0;
  try
  {
   Encap ev = db.QuerySingle("transAudit","*",
   "WHERE transAuditOfKey="+keys[sequence]+" AND "+
   "transAuditByID="+usrID+";");
   if(ev != null)
   {
    done = true;
    tk = ev.extractInteger("transAuditKey",0);
   }
   Encap e = new Encap("transAudit");
   e.setNameVal("transAuditOfKey",keys[sequence]);
   e.setNameVal("transAuditByID",usrID);
   e.setNameVal("transAuditTime","CURRENT_TIME");
   e.setNameVal("transAuditDate","CURRENT_DATE");
   if(done)
   {
    e.setCondition("WHERE transAuditKey="+tk+";");
    db.UpdateData((Encap)e.clone());
   }
   else
    db.InsertData((Encap)e.clone());
   e.clear();
   if(ev != null) ev.clear();
   e = null;
   ev = null;
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace(System.out);
   error.append(sqle.getMessage());
  }

 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == auditButton || jb == skipNextButton)
   {
    if(jb == auditButton) processAudit(sequence);
    sequence+=1;
    System.out.println("sequence: "+sequence+" size: "+result.size());
    if(sequence == result.size() && jb == skipNextButton)
    {
     Mandalatama.infoDisplay("There is no more data available","Info");
		 sequence-=1;
     return;
    }
		else if(sequence == result.size() && jb == auditButton)
		{
     Mandalatama.infoDisplay("No more data to be audit","Info");
		 sequence-=1;
		 return;
		}

    if(error.length() == 0)
    {
     sresult.removeAllElements();
     sresult.add(result.get(sequence));
     td.initData(sresult);
     table.revalidate();
     table.repaint();
    }
   }
   else if(jb == skipPrevButton)
   {
    sequence-=1;
    if(sequence < 0)
    {
     Mandalatama.infoDisplay("There is no more data available","Info");
		 sequence+=1;
     return;
    }
    sresult.removeAllElements();
    sresult.add(result.get(sequence));
    td.initData(sresult);
    table.revalidate();
    table.repaint();
   }
   else if(jb == closeButton)
   {
    close();
   }
   if(error.length()>0)
   {
    Mandalatama.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
   }
  }
 }


 private class tableData extends AbstractTableModel
 {
  public final int TKEY = 0; // transKey
  public final int TINV = 1; // transInvNo
  public final int TDES = 2; // transDesc
  public final int TRMK = 3; // transRemarks
  public final int TTYP = 4; // transPaymentType
  public final int TMTD = 5; // transPaymentMethod
  public final int TNOD = 6; // transNoDoc
  public final int TCUR = 7; // transPaymentCurrency
  public final int TAMT = 8; // transPaymentAmount
	public final int TPDT = 9; // transPaymentDate
	public final int TPTM =10; // trans
  public int rowLength = 0;
  public int colLength = 0;
  Vector dataRow;
  public final String[] colNames =
  {"Trans\nKey","Invoice\nNo","Desc","Remarks","Type","Method",
  "No.\nDoc","Currency","Amount"};

  public tableData(Vector ve)
  {
   rowLength = ve.size();
   colLength = colNames.length;
   initData(ve);
  }
  public void initData(Vector ve)
  { dataRow = ve; }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colNames.length; }
  public String getColumnName(int column)
  { return colNames[column]; }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public boolean isCellEditable(int row,int column)
  { return false; }
  public Object getValueAt(int row,int column)
  {
   if(row<0 || row>=getRowCount()) return " ";
   Data data = (Data)dataRow.elementAt(row);
   switch(column)
   {
    case TKEY : return data.getTransKey();
    case TINV : return data.getTransInvNo();
    case TDES : return data.getTransDesc();
    case TRMK : return data.getTransRemarks();
    case TTYP : return data.getTransType();
    case TMTD : return data.getTransMethod();
    case TNOD : return data.getTransDocNo();
    case TCUR : return data.getTransCurr();
    case TAMT : return data.getTransAmt();
   }
   return " ";
  }
  public void setValueAt(Object val,int row,int column)
  {
   if(row<0 || row>=getRowCount()) return;
   Data data = (Data)dataRow.elementAt(row);
   switch(column)
   {
    case TKEY : data.setTransKey(((Integer)val).intValue()); break;
    case TINV : data.setTransInvNo(((Integer)val).intValue()); break;
    case TDES : data.setTransDesc((String)val); break;
    case TRMK : data.setTransRemarks((String)val); break;
    case TTYP : data.setTransType((String)val); break;
    case TMTD : data.setTransMethod((String)val); break;
    case TNOD : data.setTransDocNo((String)val); break;
    case TCUR : data.setTransCurr((String)val); break;
    case TAMT : data.setTransAmt((String)val); break;
   }
   dataRow.setElementAt(data,row);
   fireTableCellUpdated(row,column);
  }
 }

 private class Data
 {
  private String dDesc = null;
  private String dCurr = null;
  private String dAmt = null;
  private String dDocNo = null;
  private String dRemark = null;
  private String dType = null;
  private String dMethod = null;
  private int tKey;
  private int tInv;

  public Data() { }
  public Data(int key,int invNo,String desc,
  String rmk,String t,String m,String docNo,
  String curr,String amt)
  {
   setTransKey(key);
   setTransInvNo(invNo);
   setTransDesc(desc);
   setTransCurr(curr);
   setTransAmt(amt);
   setTransDocNo(docNo);
   setTransRemarks(rmk);
   setTransType(t);
   setTransMethod(m);
  }

  public void setTransKey(int key)
  { tKey = key; }
  public void setTransInvNo(int invNo)
  { tInv = invNo; }
  public void setTransDesc(String desc)
  { if(desc!=null) dDesc = new String(desc); }
  public void setTransCurr(String curr)
  { if(curr!=null) dCurr = new String(curr); }
  public void setTransAmt(String amt)
  { if(amt!=null) dAmt = new String(amt); }
  public void setTransDocNo(String docNo)
  { if(docNo!=null) dDocNo = new String(docNo); }
  public void setTransRemarks(String rmk)
  { if(rmk!=null) dRemark = new String(rmk); }
  public void setTransType(String t)
  { if(t!=null) dType = new String(t); }
  public void setTransMethod(String m)
  { if(m!=null) dMethod = new String(m); }

  public Integer getTransKey()
  { return new Integer(tKey); }
  public Integer getTransInvNo()
  { return new Integer(tInv); }
  public String getTransDesc()
  { return dDesc; }
  public String getTransCurr()
  { return dCurr; }
  public String getTransAmt()
  { return dAmt; }
  public String getTransDocNo()
  { return dDocNo; }
  public String getTransRemarks()
  { return dRemark; }
  public String getTransType()
  { return dType; }
  public String getTransMethod()
  { return dMethod; }
 }

}
