import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Vector;
import java.math.BigDecimal;
import java.util.StringTokenizer;

public class ProcessEdit
{
 private int action;
 private JFrame frame;
 private JTable table;
 private tableData td;
 private JButton editButton;
 private JButton cancelButton;
 private Vector result = new Vector(10);
 private String sendCont = null;
 private int usrID = 0;
 private int key = 0;
 private int posIndex = -1;
 private int posFirst = -1;

 protected String changedCurr = null; // changed currency
 protected String changedAmnt = null; // changed amount
 protected String changedType = null; // changed type [CR / DB]
 protected String changedDate = null; // changed date
 protected String changedMethod = null; // changed method [CASH/NON-CASH]

 protected Vector masterIns = new Vector(1);
 protected Vector masterDel = new Vector(1);
 protected Vector masterUps = new Vector(6); // final storage for UPDATE
 protected Vector masterMap = new Vector(16); // storage for RETRIEVAL 
 protected Vector masterPay = new Vector(3); // storage for payment 
 protected Encap masterDate = new Encap("date"); // store all pay date
 protected Encap masterTime = new Encap("time"); // store all pay time
 protected String dateOfChange = null;
 protected String timeOfChange = null;

 protected boolean invalid = false;
 protected boolean dateFlag = false;
 protected boolean typeFlag = false;
 protected boolean firstDate = false;
 protected boolean amountFlag = false;
 protected boolean methodFlag = false;
 protected boolean currencyFlag = false;
 protected boolean amountChange = false;
 protected boolean methodChange = false;
 
 private StringBuffer error = new StringBuffer(128);

 private DBConnect db = new DBConnect();

 public static void main(String args[])
 {
  new ProcessEdit(args[0],1);
 }

 public ProcessEdit(String tkey,int userID)
 {
  if(tkey == null)
   error.append("Received invalid userID\n");
  if(error.length()>0)
  {
   Mandalatama.errorDisplay(error.toString(),"ERROR");
   return;
  }
  usrID = userID;
  key = Integer.parseInt(tkey);
  getData();
  if(error.length()>0)
  {
   Mandalatama.errorDisplay(error.toString(),"ERROR");
   return;
  }
  System.out.println("---Enter ProcessEdit---");
  frame = new JFrame("Edit Transaction Key : "+key);
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(),BorderLayout.CENTER);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Mandalatama.infoDisplay("Click on Cancel in the panel instead",
     "Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel();
  td = new tableData(result);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setModel(td);
  table.setRowHeight(20);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  for(int i=0;i<td.colLength;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   if(i == td.OLDDESC)
    column = new TableColumn(i,50,render,editor);
   else if(i == td.OLDVAL)
    column = new TableColumn(i,10,render,editor);
   else
    column = new TableColumn(i,10,render,editor);
   column.setHeaderRenderer(mlhr);
   table.addColumn(column);
  }
  JList head = new JList(new ListMod(result.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.setLayout(new BorderLayout());
  panel.setPreferredSize(new Dimension(600,250));
  panel.add(jsp,BorderLayout.CENTER);
  return panel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel();
  editButton = new JButton("Edit");
  cancelButton = new JButton("Cancel");
  ButtonListener bl = new ButtonListener();
  editButton.addActionListener(bl);
  cancelButton.addActionListener(bl);
  panel.add(editButton);
  panel.add(cancelButton);
  return panel;
 }

/**
 * getData's method is to query data from database based on transKey.
 * The result is immediately passed into processData to be refined and
 * put into the JTable data and show it.
 * @param none
 * @return none
 */
 private void getData()
 {
  try
  {
   if(!db.makeConnection("MANDALATAMA"))
    throw new SQLException("Failed to make connection to database\n");
   processData(db.QuerySingle("transaction","*",
		"WHERE transKey="+key+";"),db); 
  }
  catch(SQLException sqle)
  {
   error.append(sqle.getMessage());
   sqle.printStackTrace(System.out);
  }
 }

/**
 * processData's method is to refine the result of the getData's method.
 * the result straights from database is being process and put into
 * the data encapsulation for the JTable to show. 
 * @param Encap e - contains the result of the database query
 *        DBConnect db - contains connection to database
 * @return none
 */
 private void processData(Encap e,DBConnect db) throws SQLException
 {
  if(e == null)
  {
   error.append("No data found with transaction key: "+key+"\n"); 
   return;
  }

  // to put the sequence number to each element of the data
  int seq = 0;
  StringBuffer tDate = new StringBuffer(10);
  StringBuffer tTime = new StringBuffer(8);
  Encap e2 = new Encap(e.getTable());
  e2.setNameVal("key name","transKey");
  e2.setNameVal("key value",e.extractInteger("transKey",0));
  e2.setNameVal("pos start",0);
  if(e.extractInteger("transInvoiceNo",0)>0)
  {
   result.add(new Data("trans Invoice No",
   e.extractAll("transInvoiceNo"),""));
   e2.setNameVal("fieldName"+seq,"transInvoiceNo"); 
   e2.setNameVal("fieldValue"+seq,e.extractAll("transInvoiceNo"));
   e2.setNameVal("fieldLength"+seq,10);
   seq+=1;
  }
  result.add(new Data("trans description",
  e.extractAll("transDescription"),""));
  e2.setNameVal("fieldName"+seq,"transDescription");
  e2.setNameVal("fieldValue"+seq,e.extractAll("transDescription"));
  e2.setNameVal("fieldLength"+seq,64);
  seq+=1;
  result.add(new Data("trans Valid [Y / N]",e.extractAll("transValid"),""));
  e2.setNameVal("fieldName"+seq,"transValid");
  e2.setNameVal("fieldValue"+seq,e.extractAll("transValid"));	
  e2.setNameVal("fieldLength"+seq,1); 
  masterDate.setNameVal(String.valueOf(seq),tDate.toString());
  masterTime.setNameVal(String.valueOf(seq),tTime.toString());
  e2.setNameVal("pos end",seq);
  seq+=1;
  masterMap.add(e2.clone());
  e2.clear();
  e.clear();
  tDate.delete(0,tDate.length());
  tTime.delete(0,tTime.length());
  Encap e3 = null;
  int pkey = 0;
  boolean payMethod = false;
  Vector v = db.QueryMulti("transPayment","*",
  "WHERE transPaymentOfKey="+key+";");
  if(v != null)
  {
	 int count = 0;
   while(!v.isEmpty())
   {
    e = (Encap)v.remove(0);
    e3 = (Encap)e.clone();
    e2.setTable(e.getTable());
    tDate.append(e.extractAll("transPaymentDate"));
    tTime.append(e.extractAll("transPaymentTime"));
    pkey = e.extractInteger("transPaymentKey",0);
    e2.setNameVal("key name","transPaymentKey");
    e2.setNameVal("key value",pkey);
    payMethod = VariousCheck.checkException(e.extractAll("transPaymentMethod"));
    result.add(new Data("payment method ["+
    DateUtil.formNDate(tDate.toString())+" "+
    tTime.toString()+"]",e.extractAll("transPaymentMethod"),""));
    e2.setNameVal("pos start",seq);
    e3.setNameVal("pos start",seq);
    e2.setNameVal("fieldName"+seq,"transPaymentMethod");
    e2.setNameVal("fieldValue"+seq,e.extractAll("transPaymentMethod"));
    e2.setNameVal("fieldLength"+seq,16);
    masterDate.setNameVal(String.valueOf(seq),tDate.toString());
    masterTime.setNameVal(String.valueOf(seq),tTime.toString());
    seq+=1;
    result.add(new Data("payment type ["+
    DateUtil.formNDate(tDate.toString())+" "+
    tTime.toString()+"]",e.extractAll("transPaymentType"),""));
    e2.setNameVal("fieldName"+seq,"transPaymentType");
    e2.setNameVal("fieldValue"+seq,e.extractAll("transPaymentType"));
    e2.setNameVal("fieldLength"+seq,16);
    masterDate.setNameVal(String.valueOf(seq),tDate.toString());
    masterTime.setNameVal(String.valueOf(seq),tTime.toString());
    seq+=1;
    result.add(new Data("payment currency ["+
    DateUtil.formNDate(tDate.toString())+" "+
    tTime.toString()+"]",e.extractAll("transPaymentCurr"),""));
    e2.setNameVal("fieldName"+seq,"transPaymentCurr");
    e2.setNameVal("fieldValue"+seq,e.extractAll("transPaymentCurr"));
    e2.setNameVal("fieldLength"+seq,3);
    masterDate.setNameVal(String.valueOf(seq),tDate.toString()); 
    masterTime.setNameVal(String.valueOf(seq),tTime.toString());
    seq+=1;
    result.add(new Data("payment amount ["+
    DateUtil.formNDate(tDate.toString())+" "+
    tTime.toString()+"]",e.extractAll("transPaymentAmnt"),""));
    e2.setNameVal("fieldName"+seq,"transPaymentAmnt");
    e2.setNameVal("fieldValue"+seq,e.extractAll("transPaymentAmnt"));
    e2.setNameVal("fieldLength"+seq,15);
    masterDate.setNameVal(String.valueOf(seq),tDate.toString());
    masterTime.setNameVal(String.valueOf(seq),tTime.toString());
    seq+=1;
    result.add(new Data("payment date ["+tTime.toString()+"]",
    DateUtil.formNDate(tDate.toString()),""));
    e2.setNameVal("fieldName"+seq,"transPaymentDate");
    e2.setNameVal("fieldValue"+seq,tDate.toString());
    e2.setNameVal("fieldLength"+seq,10);
    masterDate.setNameVal(String.valueOf(seq),tDate.toString());
    masterTime.setNameVal(String.valueOf(seq),tTime.toString());
		if(count == 0) posFirst = seq;
    e2.setNameVal("pos end",seq);
    e3.setNameVal("pos end",seq);
    seq+=1;
    masterMap.add(e2.clone());
    masterPay.add(e3.clone());
    e3.clear();
    e2.clear();
    e.clear();
    e = db.QuerySingle("transRemarks","*","WHERE transRemarksOfKey="+pkey+";");
    if(e != null)
    {
     e2.setTable(e.getTable());
     e2.setNameVal("key name","transRemarksKey");
     e2.setNameVal("key value",e.extractInteger("transRemarksKey",0));
     result.add(new Data("payment remarks ["+
     DateUtil.formNDate(tDate.toString())+" "+
     tTime.toString()+"]",e.extractAll("transRemarksContent"),""));
     e2.setNameVal("pos start",seq);
     e2.setNameVal("fieldName"+seq,"transRemarksContent");
     e2.setNameVal("fieldValue"+seq,e.extractAll("transRemarksContent"));
     e2.setNameVal("fieldLength"+seq,128);
     e2.setNameVal("pos end",seq);
     seq+=1;
     masterMap.add(e2.clone());
     e2.clear();
     e.clear();
    }
    if(!payMethod)
    {
     e = db.QuerySingle("transDocument","*","WHERE transDocOfKey="+pkey+";");
     if(e != null)
     {
      e2.setTable(e.getTable());
      e2.setNameVal("key name","transDocKey");
      e2.setNameVal("key value",e.extractInteger("transDocKey",0));
      result.add(new Data("payment document no. ["+
      DateUtil.formNDate(tDate.toString())+" "+
      tTime.toString()+"]",e.extractAll("transDocNo"),""));
      e2.setNameVal("pos start",seq);
      e2.setNameVal("fieldName"+seq,"transDocNo");
      e2.setNameVal("fieldValue"+seq,e.extractAll("transDocNo"));
      e2.setNameVal("fieldLength"+seq,32);
      e2.setNameVal("pos end",seq);
      seq+=1;
      masterMap.add(e2.clone());
      e2.clear();
      e.clear();
     }
    }
    tDate.delete(0,tDate.length());
    tTime.delete(0,tTime.length());
		count++;
   } // end of while-loop
  } // end of if-not null payment
 } // end processData

 private void clearMaster()
 {
  if(masterUps != null) masterUps.removeAllElements();
  if(masterIns != null) masterIns.removeAllElements();
  if(masterDel != null) masterDel.removeAllElements();
	changedCurr = null;
	changedAmnt = null;
	changedType = null;
	changedDate = null;
	changedMethod = null;
  invalid = false;
  dateFlag = false;
  typeFlag = false;
	firstDate = false;
  amountFlag = false;
  methodChange = false;
  currencyFlag = false;
  amountChange = false;
  dateOfChange = null;
  timeOfChange = null;
  posIndex = -1;
 }

 public void insertRes(Encap e)
 {
  if(masterUps != null) consolidate(e);
 }

/**
 * consolidate's method is to consolidate the table of the different
 * elements of the same table into just one Encapsulation.
 * @param Encap e - the encapsulation data
 * @return none
 */
 private void consolidate(Encap e)
 {
  if(masterUps == null) masterUps = new Vector(6);
  int size = masterUps.size();
  int gsize= 0;
  int pos = 0;
  Encap m = null;
  boolean match = false;
  for(int i=0;i<size;i++)
  {
   m = (Encap)((Encap)masterUps.get(i)).clone();
   if(m.getTable().equalsIgnoreCase(e.getTable()))
   {
    gsize = e.getSize(); 
    for(int x=0;x<gsize;x++)
    {
     if(!e.getName(x).equalsIgnoreCase(m.getName(x)))
     {
      m.setNameVal(e.getName(x),e.getValue(x));
      match = true;
      pos = i;
      break;
     }
    }
   }
   if(match) break;
   m.clear();
  } // end for-loop
  if(match)
  {
   masterUps.setElementAt(m.clone(),pos);
  }
  else
  {
   masterUps.add(e.clone());
  }
  if(m != null) m.clear();
 }

/**
 * processAmountChanged's method is process all the amount changed
 * process that happens. It responsibles for updating all the 
 * transBalance or transBankBalance
 * @param none
 * @return none
 */
 private void processAmountChanged() throws SQLException
 {
  if(posIndex == -1) return;
  System.out.println(" ==== processAmountChange posIndex: "+posIndex);

  if(invalid)
  {
   System.out.println(" ---- change invalid");
   processDeleteInvalid();
	 return;
  }

  Encap e = findRange(masterPay,posIndex);
	if(e == null)
	{
   System.out.println("No range found. Exit");
	 return;
	}
  System.out.println(" -- ++ str original ++ -- ");
  DBConnect.viewEncap(e);
  System.out.println(" -- ++ end original ++ -- ");

  String date;
	String curr;

  if(dateFlag)
  {
	 date = changedDate; 
   processChangeDate(e);
	}
	else date = e.extractAll("transPaymentDate");

	if(currencyFlag)
	{
	 curr = changedCurr;
   processChangeCurrency(e,date);
	}
	else curr = e.extractAll("transPaymentCurr");

  if(methodFlag) processChangeMethod(e,date,curr);
  if(typeFlag) processChangeType(e,date,curr);
  if(amountFlag) processChangeAmount(e,date,curr);
  e.clear();
	e = null;
 }

/**
 * processChangeCurrency's method is to process change of currency payment.
 * @param Encap e - contains the original data
 * @return none
 */
 private void processChangeCurrency(Encap e,String date)
 {
	if(e == null) return;
	System.out.println(" -- processChangeCurrency");
  if(e.extractAll("transPaymentCurr").equalsIgnoreCase(changedCurr))
	 return;
  boolean cash = VariousCheck.checkException(
	e.extractAll("transPaymentMethod"));
	Encap e2 = new Encap();

  if(cash)
	{
   e2.setTable("transBalance"); 
	 e2.setNameVal("transBalanceAmount","(transBalanceAmount-"+
	 e.extractAll("transPaymentAmnt")+")");
	 e2.setCondition("WHERE transBalanceCurrency=\""+
	 e.extractAll("transPaymentCurr")+"\" AND "+
	 "transBalanceDate>=\""+date+"\";");
   masterUps.add(e2.clone());
	 e2.clear();
	 e2.setTable("transBalance");
	 e2.setNameVal("transBalanceAmount","(transBalanceAmount+"+
	 e.extractAll("transPaymentAmnt")+")");
	 e2.setCondition("WHERE transBalanceCurrency=\""+changedCurr+"\" AND "+
	 "transBalanceDate>=\""+date+"\";");
	 masterUps.add(e2.clone());
	 e2.clear();
	}
	else
	{
   e2.setTable("transBankBalance"); 
	 e2.setNameVal("transBankBalAmount","(transBankBalAmount-"+
	 e.extractAll("transPaymentAmnt")+")");
	 e2.setCondition("WHERE transBankBalCurrency=\""+
	 e.extractAll("transPaymentCurr")+"\" AND "+
	 "transBankBalDate>=\""+date+"\";");
   masterUps.add(e2.clone());
	 e2.clear();
	 e2.setTable("transBankBalance");
	 e2.setNameVal("transBankBalAmount","(transBankBalAmount+"+
	 e.extractAll("transPaymentAmnt")+")");
	 e2.setCondition("WHERE transBankBalCurrency=\""+changedCurr+"\" AND "+
	 "transBankBalDate>=\""+date+"\";");
	 masterUps.add(e2.clone());
	 e2.clear();
	}
 }

/**
 * processChangeAmount's method is to process change of amount payment.
 * @param Encap e - contains the original data
 * @return none
 */
 private void processChangeAmount(Encap e,String date,String curr)
 {
	if(e == null) return;
	System.out.println(" -- processChangeAmount");
  if(e.extractAll("transPaymentAmnt").equalsIgnoreCase(changedAmnt))
	 return;
  boolean cash;
	if(methodFlag)
	 cash = VariousCheck.checkException(changedMethod);
	else
	 cash = VariousCheck.checkException(e.extractAll("transPaymentMethod"));

	Encap e2 = new Encap();
  BigDecimal different = new BigDecimal(changedAmnt);
	
	if(!currencyFlag)
	 different = different.subtract(e.extractBigDecimal("transPaymentAmnt"));
 
	String signing = null;
	if(typeFlag)
	{
   if(changedType.equalsIgnoreCase("DEBIT"))
		signing = new String("+");
	 else
		signing = new String("-");
	}

  if(cash)
	{
   e2.setTable("transBalance"); 
	 if(typeFlag)
		e2.setNameVal("transBalanceAmount","(transBalanceAmount"+
		 signing+different+")");
	 else
    e2.setNameVal("transBalanceAmount","(transBalanceAmount+"+
     different+")");
	 e2.setCondition("WHERE transBalanceCurrency=\""+curr+"\" AND "+ 
	 "transBalanceDate>=\""+date+"\";");
	}
	else
	{
   e2.setTable("transBankBalance"); 
	 if(typeFlag)
		e2.setNameVal("transBalanceAmount","(transBankBalAmount"+
		 signing+different+")");
	 else
    e2.setNameVal("transBankBalAmount","(transBankBalAmount+"+
     different+")");
	 e2.setCondition("WHERE transBankBalCurrency=\""+curr+"\" AND "+
	 "transBankBalDate>=\""+date+"\";");
	}
	masterUps.add(e2.clone());
	e2.clear();
 }
 
/**
 * processChangeMethod's method is to process change of method payment
 * CASH and NON-CASH.
 * @param Encap e - contains the original data
 * @return none
 */
 private void processChangeMethod(Encap e,String date,String curr)
 {
	if(e == null) return;
	System.out.print(" -- processChangeMethod ");
	System.out.print(e.extractAll("transPaymentMethod")+" TO ");
	System.out.print(changedMethod+" ");
  if(e.extractAll("transPaymentMethod").equalsIgnoreCase(changedMethod))
	 return; // both are exactly the same so do nothing
  boolean cash1 = VariousCheck.checkException(changedMethod);
  boolean cash2 = VariousCheck.checkException(
	 e.extractAll("transPaymentMethod"));
	//both are the same type of method so do nothing
	if(cash1 && cash2)
	{
	 System.out.println("both true");
	 return;
	}
  if(!cash1 && !cash2)
	{
	 System.out.println("both false");
	 return;
  }

	Encap e2 = new Encap();
	if(cash1) // change to cash
	{
	 System.out.println("NON-CASH TO CASH");
	 e2.setTable("transBankBalance");
	 e2.setNameVal("transBankBalAmount","(transBankBalAmount-"+
	 e.extractAll("transPaymentAmnt")+")");
	 e2.setCondition("WHERE transBankBalCurrency=\""+curr
	 +"\" AND transBankBalDate>=\""+date+"\";");
   masterUps.add(e2.clone());
   e2.clear();
   e2.setTable("transBalance");
	 e2.setNameVal("transBalanceAmount","(transBalanceAmount+"+
	 e.extractAll("transPaymentAmnt")+")");
	 e2.setCondition("WHERE transBalanceCurrency=\""+curr
	 +"\" AND transBalanceDate>=\""+date+"\";");
	}
	else // change to non-cash
	{
	 System.out.println("CASH TO NON-CASH");
   e2.setTable("transBalance");
	 e2.setNameVal("transBalanceAmount","(transBalanceAmount-"+
	 e.extractAll("transPaymentAmnt")+")");
	 e2.setCondition("WHERE transBalanceCurrency=\""+curr
	 +"\" AND transBalanceDate>=\""+date+"\";");
	 masterUps.add(e2.clone());
   e2.clear();
   e2.setTable("transBankBalance");
	 e2.setNameVal("transBankBalAmount","(transBankBalAmount+"+
	 e.extractAll("transPaymentAmnt")+")");
	 e2.setCondition("WHERE transBankBalCurrency=\""+curr
   +"\" AND transBankBalDate>=\""+date+"\";");
	}
  masterUps.add(e2.clone());
	e2.clear();
	e2 = null;
 }

/**
 * processChangeType's method is to process the change of type [DEBIT/CREDIT]
 * @param Encap e - contains the original data
 * @return none
 */
 private void processChangeType(Encap e,String date,String curr)
 {
	if(e == null) return;
	System.out.print(" --- processChangeType");
	if(e.extractAll("transPaymentType").equalsIgnoreCase(changedType))
		return;
  Encap e2 = new Encap();	
	boolean cash;
	if(methodFlag)
	 cash = VariousCheck.checkException(changedMethod);
  else
	 cash = VariousCheck.checkException(e.extractAll("transPaymentMethod"));
  if(changedType.equalsIgnoreCase("DEBIT")) // change CREDIT to DEBIT
	{
	 System.out.println(" CREDIT > DEBIT");
   if(cash)
	 {
    e2.setTable("transBalance");
    e2.setNameVal("transBalanceAmount","(transBalanceAmount+"+
		e.extractAll("transPaymentAmnt")+")");
		e2.setCondition("WHERE transBalanceCurrency=\""+curr
    +"\" AND transBalanceDate>=\""+date+"\";");
	 }
	 else
	 {
    e2.setTable("transBankBalance");
    e2.setNameVal("transBankBalAmount","(transBankBalAmount+"+
		e.extractAll("transPaymentAmnt")+")");
		e2.setCondition("WHERE transBankBalCurrency=\""+curr
    +"\" AND transBankBalDate>=\""+date+"\";");
	 }
	}
	else // change DEBIT to CREDIT 
	{
	 System.out.println(" DEBIT > CREDIT");
   if(cash)
	 {
    e2.setTable("transBalance");
    e2.setNameVal("transBalanceAmount","(transBalanceAmount-"+
		e.extractAll("transPaymentAmnt")+")");
		e2.setCondition("WHERE transBalanceCurrency=\""+curr
    +"\" AND transBalanceDate>=\""+date+"\";");
	 }
	 else
	 {
    e2.setTable("transBankBalance");
    e2.setNameVal("transBankBalAmount","(transBankBalAmount-"+
		e.extractAll("transPaymentAmnt")+")");
		e2.setCondition("WHERE transBankBalCurrency=\""+curr
    +"\" AND transBankBalDate>=\""+date+"\";");
	 }
	}
	masterUps.add(e2.clone());
	e2.clear();
	e2 = null;
 }

/**
 * processChangeDate's method is to process the change of date
 * @param Encap e - contains all the original data
 *        String diffAmount - the change of amount
 * @return none
 */
 private void processChangeDate(Encap e)
	throws SQLException
 {
	if(e == null) return;
  System.out.println(" -- processChangeDate");
	Encap e2 = new Encap();
	if(VariousCheck.checkException(e.extractAll("transPaymentMethod")))
	{
	 e2.setTable("transBalance");
	 e2.setNameVal("transBalanceAmount","(transBalanceAmount-"+
	 e.extractAll("transPaymentAmnt")+")");
	 e2.setCondition("WHERE transBalanceCurrency=\""+
	 e.extractAll("transPaymentCurr")+"\" AND transBalanceDate>=\""+
	 e.extractAll("transPaymentDate")+"\";");
	 masterUps.add(e2.clone());
	 e2.clear();
	 if(checkBalanceExist(e.extractAll("transPaymentMethod"),changedDate))
	 {
	  e2.setTable("transBalance");
	  e2.setNameVal("transBalanceAmount","(transBalanceAmount+"+
	  e.extractAll("transPaymentAmnt")+")");
    e2.setCondition("WHERE transBalanceCurrency=\""+
		e.extractAll("transPaymentCurr")+"\" AND "+
		"transBalanceDate>=\""+changedDate+"\";");
	  masterUps.add(e2.clone());
	  e2.clear();
	 }
	 else // NO BALANCE EXIST ON changedDATE
	 {
    processInNewBalance(e);
	 }
	}
  else
  {
   e2.setTable("transBankBalance");
   e2.setNameVal("transBankBalAmount","(transBankBalAmount-"+
	 e.extractAll("transPaymentAmnt")+")");
	 e2.setCondition("WHERE transBankBalCurrency=\""+
	 e.extractAll("transPaymentCurr")+"\" AND "+
	 "transBankBalDate>=\""+changedDate+"\";");
	 masterUps.add(e2.clone());
	 e2.clear();
	 if(checkBalanceExist(e.extractAll("transPaymentMethod"),changedDate))
	 {
	  e2.setTable("transBankBalance");
	  e2.setNameVal("transBankBalAmount","(transBankBalAmount+"+
	  e.extractAll("transPaymentAmnt")+")");
	  e2.setCondition("WHERE transBankBalCurrency=\""+
		e.extractAll("transBankBalCurrency")+"\" AND "+
		"transBankBalDate>=\""+changedDate+"\";");
	  masterUps.add(e2.clone());
	  e2.clear();
	 }
	 else // NO BALANCE EXIST ON changedDate
	 {
    processInNewBalance(e);
	 }
	}
	e2 = null;
 }

/**
 * checkBalanceExist's method is check whether on the date specific
 * the balance exist or not. 
 * @param String methodTrans - type of transaction
 *        String dateTrans - date of transaction
 * @return boolean true if balance exist already else false
 */
 private boolean checkBalanceExist(String methodTrans,String dateTrans)
	throws SQLException
 {
  if(methodTrans == null) throw new SQLException("Null Type Transaction");
	if(dateTrans == null) throw new SQLException("Null Date Transaction");
	boolean cash = VariousCheck.checkException(methodTrans);
	Vector v = null;
	if(cash)
	{
   v = db.QueryMulti("transBalance","*","WHERE transBalanceDate=\""+
	 dateTrans+"\";");
	}
	else
	{
   v = db.QueryMulti("transBankBalance","*","WHERE transBankBalDate=\""+
	 dateTrans+"\";");
	}

	if(v == null) return false;
	v.removeAllElements();
	v = null;
	return true;
 }

/**
 * processInNewBalance's method is to process the Edit to the new date
 * that has no balance previously. It will insert the new balance in
 * all currency then update the amount
 * @param Encap e - contains the original Payment
 *        String diff - contains the different of balance
 * @return BigDecimal of the specific date Balance of CASH/NON-CASH
 */
 private void processInNewBalance(Encap e) throws SQLException
 {
  if(e == null) return;
	Vector v = null;
	Encap e2 = null;
	Encap e3 = new Encap();
	boolean cash = VariousCheck.checkException(
	 e.extractAll("transPaymentMethod"));
	String date = findMinDateBalance(e.extractAll("transPaymentDate"),cash);
	if(cash)
	{
   v = db.QueryMulti("transBalance","*","WHERE transBalanceDate=\""+
       date+"\";");
   if(v != null)
	 {
    while(!v.isEmpty())
		{
     e2 = (Encap)v.remove(0);
     e3.setTable("transBalance");
		 e3.setNameVal("transBalanceCurrency",
			e2.extractAll("transBalanceCurrency"));
		 e3.setNameVal("transBalanceAmount",
			e2.extractAll("transBalanceAmount"));
		 e3.setNameVal("transBalanceDate",changedDate);
		 masterIns.add(e3.clone());
		 e3.clear();
		 e2.clear();
		}
		e2.setTable("transBalance");
		e2.setNameVal("transBalanceAmount","(transBalanceAmount+"+
		e.extractAll("transPaymentAmnt")+")");
		e2.setCondition("WHERE transBalanceCurrency=\""+
		e.extractAll("transPaymentCurr")+"\" AND transBalanceDate>=\""+
		changedDate+"\";");
		masterUps.add(e2.clone());
		e2.clear();
	 }
	}
	else // NON-CASH
	{
   v = db.QueryMulti("transBankBalance","*","WHERE transBankBalDate=\""+
       date+"\";");
	 if(v != null)
	 {
    while(!v.isEmpty())
		{
     e2 = (Encap)v.remove(0);
     e3.setTable("transBankBalance");
		 e3.setNameVal("transBankBalCurrency",
		 e2.extractAll("transBankBalCurrency"));
		 e3.setNameVal("transBankBalAmount",
		 e2.extractAll("transBankBalAmount"));
		 e3.setNameVal("transBankBalDate",changedDate);
		 masterIns.add(e3.clone());   
		 e2.clear();
		}
		e2.setTable("transBankBalance");
		e2.setNameVal("transBankBalAmount","(transBalanceAmount+"+
		e.extractAll("transPaymentAmnt")+")");
		e2.setCondition("WHERE transBankBalCurrency=\""+
		e.extractAll("transPaymentCurr")+"\" AND transBankBalDate>=\""+
		changedDate+"\";");
		masterUps.add(e2.clone());
		e2.clear();
	 }
	}
 }

/**
 * findMinDateBalancec's method is to find minimum date that has a balance
 * exist. it compares the changedDate [new date enter by user] and the
 * existing date of payment [previously enter]. Then take the smallest
 * and then query it to database. Once it returns with the query result,
 * it returns the date. if it does not return any result, it returns the 
 * smallest of the two dates [changedDate or datePayment]
 * @param previousDate - previously enter date
 * @return date - the minimum date that balance exist
 */
 private String findMinDateBalance(String prevDate,boolean cash) 
	throws SQLException
 {
  if(prevDate == null) throw new SQLException("previous date is null");
	if(changedDate == null) throw new SQLException("changed date is null");
	
	if(changedDate.equalsIgnoreCase(prevDate)) return prevDate;

	int code = DateUtil.compareDate(changedDate,prevDate);
	String date = null;
  if(code == -1)
	{
   // user wants to change backward - changedDate is smaller
	 if(cash)
		date = findPastCashBalance(changedDate,prevDate); 
	 else
    date = findPastNonCashBalance(changedDate,prevDate);
	}
	else if(code == 1)
	{
   // user wants to change forward - changedDate is bigger
	 if(cash)
		date = findPastCashBalance(changedDate,prevDate);
	 else
		date = findPastNonCashBalance(changedDate,prevDate);
	}
	return date;
 }

 private String findPastCashBalance(String cDate,String pDate) 
	throws SQLException
 {
  if(cDate == null) throw new SQLException("cDate is null");
	Vector cv = null;

	// if the changed date has no balance
	cv = db.QueryMulti("transBalance","transBalanceDate",
	 "WHERE transBalanceDate<\""+cDate+
	 "\" ORDER BY transBalanceDate DESC LIMIT 1;");

  if(cv == null) return pDate;	
  
	Encap e = (Encap)cv.remove(0);
	return e.extractAll("transBalanceDate");
 }

 private String findPastNonCashBalance(String cDate,String pDate) 
	throws SQLException
 {
  if(cDate == null) throw new SQLException("cDate is null");
	Vector cv = null;

	// if the changed date has no balance
	cv = db.QueryMulti("transBankBalance","transBankBalDate",
	 "WHERE transBankBalDate<\""+cDate+
	 "\" ORDER BY transBankBalDate DESC LIMIT 1;");
  
	if(cv == null) return pDate;

	Encap e = (Encap)cv.remove(0);
	return e.extractAll("transBankBalDate");
 }
 
/**
 * processDeleteInvalid's method is to process the transaction that is
 * undesire anymore or invalid. It will delete the transaction
 * from the database.
 * @param none
 * @return none
 */
 private void processDeleteInvalid()
 {
  Encap en1;
  Encap en2 = new Encap();
  boolean nonCash = false; // assume cash
  if(!masterIns.isEmpty()) masterIns.removeAllElements();
  if(!masterUps.isEmpty()) masterUps.removeAllElements();
  if(!masterDel.isEmpty()) masterDel.removeAllElements();
  while(!masterPay.isEmpty())
  {
   en1 = (Encap)masterPay.remove(0);
   if(VariousCheck.checkException(en1.extractAll("transPaymentMethod")))
   {
    en2.setTable("transBalance");
    en2.setNameVal("transBalanceAmount","(transBalanceAmount-"+
    en1.extractAll("transPaymentAmnt")+")");
    en2.setCondition("WHERE transBalanceDate>=\""+
    en1.extractAll("transPaymentDate")+"\" AND transPaymentCurr=\""+
    en1.extractAll("transPaymentCurr")+"\";");
    masterUps.add(en2.clone());
    en2.clear();
    nonCash = false;
   }
   else
   {
    en2.setTable("transBankBalance");
    en2.setNameVal("transBankBalance","(transBankBalAmount-"+
    en1.extractAll("transPaymentAmnt")+")");
    en2.setCondition("WHERE transBankBalDate>=\""+
    en1.extractAll("transPaymentDate")+"\" AND transPaymentCurr=\""+
    en1.extractAll("transPaymentCurr")+"\";"); 
    masterUps.add(en2.clone());
    en2.clear();
    nonCash = true; 
   }
   en1.clear();
  }
  en1 = new Encap("transaction");
  en1.setCondition("WHERE transKey="+key+";");
  masterDel.add(en1.clone());
  en1.clear();
  en1.setTable("transPayment");
  en1.setCondition("WHERE transPaymentOfKey="+key+";");
  masterDel.add(en1.clone());
  en1.clear();
 }

/**
 * findRange's mehtod is to find encap inside of Vector that carries
 * a specific range of position or index. 
 * @param Vector v - contains encapsulations of result of query
 *        int i - contains the index for the range
 * @return Encap e
 */
 private Encap findRange(Vector m,int i)
 {
  if(m == null) return null;
  int size = m.size();
  int start = 0;
  int end = 0;
  Encap e = null;
  boolean found = false;
  for(int j=0;j<size;j++)
  {
   e = (Encap)((Encap)m.get(j)).clone();
   start = e.extractInteger("pos start",0);
   end = e.extractInteger("pos end",0);
   if(i >= start && i <= end)
   {
    found = true;
    break;
   }
   e.clear();
  }
  if(!found) return null;
  return e;
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == editButton)
   {
    try
    {
     if(processCollect())
     {
      if(amountChange) processAmountChanged();
      commitChanges(db);
      Mandalatama.infoDisplay("Successfully update the database","Update");
      clearMaster();
      close();
     }
    }
    catch(SQLException sqle)
    {
     sqle.printStackTrace(System.out);
     error.append(sqle.getMessage());
    }
   }
   else
    close();
   if(error.length()>0)
   {
    Mandalatama.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
    clearMaster();
   }
  } // end of actionPerformed
 } // end of class ButtonListener


/** 
 * checkAll's method is to check the user input and verify the length
 * of user input
 * @param int index - the sequence number of the input.
 *        int length - the max length
 *        String content - the user input
 *        Encap c - the original content
 * @return none
 */
 private void checkAll(int index,int length,String content,Encap c)
 {
  if(length > c.extractInteger("fieldLength"+index,0))
  {
   error.append("Input of Row["+(index+1)+"] exceed the max length: "+
   c.extractAll("fieldLength"+index)+"\n");
  }
  String name = c.extractString("fieldName"+index,null);
  System.out.println("checkAll index: "+index+" name: "+name+
	" content:"+content); 
  // check Invoice No
  if(name.equalsIgnoreCase("transInvoiceNo"))
  {
   if(!VariousCheck.checkInt(content,1))
   {
    error.append("Input of Row["+(index+1)+"] "+
    "Invoice No must be digits only\n");
   }
  }
  else if(name.equalsIgnoreCase("transValid"))
  {
   // check Transaction Validity
   if(!content.equalsIgnoreCase("Y")&&!content.equalsIgnoreCase("N"))
   {
    error.append("Input of Row["+(index+1)+"] only take Y or N input\n");
   }
   else
   {
    if(posIndex == -1) posIndex = index;
    amountChange = true;
    invalid = true;
   }
  }
  else if(name.equalsIgnoreCase("transPaymentMethod"))
  {
   // check Payment Method
   if(!VariousCheck.checkInclude(Mandalatama.typeMethod,content))
   {
    error.append("Input of Row["+(index+1)+"] Payment Method You "+
    "enter is not in the list\n");
   }
   else 
   {
    if(dateOfChange == null)
    {
     dateOfChange = masterDate.extractAll(String.valueOf(index));
     timeOfChange = masterTime.extractAll(String.valueOf(index));
     if(posIndex == -1) posIndex = index;
     methodChange = true;
     methodFlag = true;
     amountChange = true;
		 changedMethod = content;
    }
    else if(!dateOfChange.equalsIgnoreCase(
    masterDate.extractAll(String.valueOf(index))) ||
    !timeOfChange.equalsIgnoreCase(masterTime.extractAll(
    String.valueOf(index))))
    {
     if(error.toString().indexOf("Hanya")< 0)
     error.append("Hanya diperbolehkan mengubah 1 payment per 1 Edit\n"+
     "Untuk mengubah 2 payment dalam 1 transKey dibutuhkan 2 kali Edit\n");
    }
    else
    {
     methodChange = true;
     methodFlag = true;
     amountChange = true;
		 changedMethod = content;
    }
   }
  }
  else if(name.equalsIgnoreCase("transPaymentType"))
  {
   // check Payment Type
   if(!VariousCheck.checkInclude(Mandalatama.typeRecord,content))
   {
    error.append("Input of Row["+(index+1)+"] Payment Type You enter is not "+
    "in the list\nValid Payment Type is CREDIT or DEBIT\n");
   }
   else
   {
    if(dateOfChange == null)
    {
     dateOfChange = masterDate.extractAll(String.valueOf(index));
     timeOfChange = masterTime.extractAll(String.valueOf(index));
     if(posIndex == -1) posIndex = index;
     amountChange = true;
     typeFlag = true;
     changedType = content;
    }
    else if(!dateOfChange.equalsIgnoreCase(
    masterDate.extractAll(String.valueOf(index))) ||
    !timeOfChange.equalsIgnoreCase(masterTime.extractAll(
    String.valueOf(index))))
    {
     if(error.toString().indexOf("Hanya")< 0)
     error.append("Hanya diperbolehkan mengubah 1 payment per 1 Edit\n"+
     "Untuk mengubah 2 payment dalam 1 transKey dibutuhkan 2 kali Edit\n");
    }
    else
    {
     typeFlag = true;
     amountChange = true;
     changedType = content;
    }
   }
  }
  else if(name.equalsIgnoreCase("transPaymentCurr"))
  {
   // check Payment Currency
   if(!VariousCheck.checkInclude(Mandalatama.typeCurrency,content))
   {
    error.append("Input of Row["+(index+1)+"] Payment Currency You enter "+
    "is not in the list of currency\n");
   }
   else
   {
    if(dateOfChange == null)
    {
     dateOfChange = masterDate.extractAll(String.valueOf(index));
     timeOfChange = masterTime.extractAll(String.valueOf(index));
     if(posIndex == -1) posIndex = index;
     amountChange = true;
     currencyFlag = true;
     changedCurr = content;
    }
    else if(!dateOfChange.equalsIgnoreCase(
    masterDate.extractAll(String.valueOf(index))) ||
    !timeOfChange.equalsIgnoreCase(masterTime.extractAll(
    String.valueOf(index))))
    {
     if(error.toString().indexOf("Hanya")< 0)
     error.append("Hanya diperbolehkan mengubah 1 payment per 1 Edit\n"+
     "Untuk mengubah 2 payment dalam 1 transKey dibutuhkan 2 kali Edit\n");
    }
    else
    {
     amountChange = true;
     currencyFlag = true;
     changedCurr = content;
    }
   }
  }
  else if(name.equalsIgnoreCase("transPaymentAmnt"))
  {
   // check Payment Amount
   if(!VariousCheck.checkInt(content,3))
   {
    error.append("Input of Row["+(index+1)+"] Payment Amount "+
    "must be valid digits\n");
   }
   else
   {
    if(dateOfChange == null)
    {
     dateOfChange = masterDate.extractAll(String.valueOf(index));
     timeOfChange = masterTime.extractAll(String.valueOf(index));
     if(posIndex == -1) posIndex = index;
     amountChange = true;
     amountFlag = true;
     changedAmnt = content;
    }
    else if(!dateOfChange.equalsIgnoreCase(
    masterDate.extractAll(String.valueOf(index))) ||
    !timeOfChange.equalsIgnoreCase(masterTime.extractAll(
    String.valueOf(index))))
    {
     if(error.toString().indexOf("Hanya")< 0)
     error.append("Hanya diperbolehkan mengubah 1 payment per 1 Edit\n"+
     "Untuk mengubah 2 payment dalam 1 transKey dibutuhkan 2 kali Edit\n");
    }
    else
    {
     amountChange = true;
     amountFlag = true;
     changedAmnt = content;
    }
   }
  }
  else if(name.equalsIgnoreCase("transPaymentDate"))
  {
   // check Payment Date
   if(!VariousCheck.checkDate(content))
   {
    error.append("Invalid date format. Valid date format: DD-MM-YYYY\n"+
    "i.e: 31-12-2004\n");
   }
   else
   {
    if(dateOfChange == null)
    {
     dateOfChange = masterDate.extractAll(String.valueOf(index));
     timeOfChange = masterTime.extractAll(String.valueOf(index));
     if(posIndex == -1) posIndex = index;
		 changedDate = DateUtil.formSQLDate(content);
     amountChange = true;
     dateFlag = true;
    }
    else if(!dateOfChange.equalsIgnoreCase(
    masterDate.extractAll(String.valueOf(index))) || 
    !timeOfChange.equalsIgnoreCase(masterTime.extractAll(
    String.valueOf(index)))) 
    {
     if(error.toString().indexOf("Hanya")< 0)
     error.append("Hanya diperbolehkan mengubah 1 payment per 1 Edit\n"+
     "Untuk mengubah 2 payment dalam 1 transKey dibutuhkan 2 kali Edit\n");
    }
    else
    {
     dateFlag = true;
     amountChange = true;
		 changedDate = DateUtil.formSQLDate(content);
    }
    // Update the date of transaction if 1st transPayment date 
    // is moved so is  the transaction on that date
    if(posFirst == index && error.length()==0)
    {
     firstDate = true;
     Encap en = new Encap("transaction");
     en.setNameVal("transDate",DateUtil.formSQLDate(content));
     en.setNameVal("transTime","CURRENT_TIME");
     en.setCondition("WHERE transKey="+key+";");
     masterUps.add(en.clone());
     en.clear();
     en = null;
    }
   } 
	} 
  System.out.println("exit checkAll: "+name+" : "+content+" > amount: "+
  amountChange);
 } // end of checkAll

/**
 * processCollect's method is to collect all the user's input.
 * @param none
 * @return boolean true if all valid input else false 
 */
 public boolean processCollect()
 {
  boolean flag = true;
  int row = td.rowLength;
  int col = td.NEWVAL;
  int len = 0;
  Encap con = null;
  Encap e = new Encap();
  StringBuffer tmp = new StringBuffer(128);
  System.out.println("Enter processCollect xxx ");
  for(int i=0;i<row;i++)
  {
   tmp.append(((String)td.getValueAt(i,col)).trim());
   len = tmp.length();
   if(invalid) return true;
   if(len >= 1)
   {
    con = findRange(masterMap,i);
    if(con != null)
    {
     checkAll(i,len,tmp.toString(),con);
     if(error.length() == 0)
     {
      e.setTable(con.getTable()); 
      if(DateUtil.verifyDateFormat(tmp.toString()))
       e.setNameVal(con.extractString("fieldName"+i,null),
     	 DateUtil.formSQLDate(tmp.toString()));
      else
       e.setNameVal(con.extractString("fieldName"+i,null),
       tmp.toString());
      e.setCondition("WHERE "+con.extractAll("key name")+"="+
      con.extractAll("key value")+";");
      insertRes((Encap)e.clone());
      e.clear();
      if(methodChange) additionalInput(i,tmp.toString(),con);
     }
     else flag = false;
    }
   }
   tmp.delete(0,tmp.length());
  }
  System.out.println("exit processCollect xxx ");
  return flag;
 }

/** 
 * commitChanges' method is to commit the changes to the database
 * @param DBConnect db - contains the connection to database
 * @return none
 */
 public void commitChanges(DBConnect db) throws SQLException
 {
  if(masterIns.size()>0)
  {
   System.out.println("masterIns ---- size: "+masterIns.size());
   for(int b=0;b<masterIns.size();b++)
    db.viewEncap((Encap)((Encap)masterIns.get(b)).clone());
   db.InsertMulti(masterIns);
  }

  if(masterUps.size()>0) 
  {
   System.out.println("masterUps ---- size: "+masterUps.size());
//	 if(masterUps.size()>1)
//		masterUps = rearrangeVector(masterUps);
   for(int i=0;i<masterUps.size();i++)
    db.viewEncap((Encap)((Encap)masterUps.get(i)).clone());
   db.UpdateMulti(masterUps);
  }
  if(masterDel.size()>0)
  {
   System.out.println("masterDel ---- size: "+masterDel.size());
//	 if(masterDel.size()>1)
//	  masterDel = rearrangeVector(masterDel);
   for(int y=0;y<masterDel.size();y++)
   {
    db.viewEncap((Encap)((Encap)masterDel.get(y)).clone());
    db.DeleteSingle((Encap)masterDel.get(y));
   }
  }
 }

/**
 * rearrangeVector's method is to rearrange vector. If it finds 
 * the identical Encap's name, value, and condition.
 * @param Vector v
 * @return Vector v - rearrange
 */
 private Vector rearrangeVector(Vector v)
 {
	if(v == null) return null;
  Encap[] arrayEn = new Encap[v.size()];

	//fill the array of Encap
	int size = v.size();
	for(int i=0;i<size;i++)
	 arrayEn[i] = (Encap)((Encap)v.elementAt(i)).clone();


  for(int h=0;h<size;h++)
	 for(int o=h+1;o<size;o++)
		if(arrayEn[h]!=null && arrayEn[o]!=null)
		{
	//	 System.out.print("h["+h+"] o["+o+"]");
     if(compareEncap(arrayEn[h],arrayEn[o]))
			arrayEn[o] = null;
		}
  
	Vector v2 = new Vector(size);
	for(int z=0;z<size;z++)
	 if(arrayEn[z] != null)
    v2.add(arrayEn[z].clone());	
  
	return v2;
 }

 private boolean compareEncap(Encap e1, Encap e2)
 {
	boolean eTable = false;
	boolean eName  = false;
	boolean eValue = false;
	boolean eCond  = false;

	if(e1.getTable().equalsIgnoreCase(e2.getTable())) eTable = true;
	if(e1.getCondition().equalsIgnoreCase(e2.getCondition())) eCond = true;

	if(eTable && eCond)
	{
   if(e1.getName(0).equalsIgnoreCase(e2.getName(0))) eName = true;
	 if(e1.getValue(0).equalsIgnoreCase(e2.getValue(0))) eValue = true;
  }

	if(eTable && eName && eValue && eCond)
	{
	 System.out.println("==== All TRUE =====");
	 return true;
	}
	System.out.println("==== NOT ALL TRUE ====");
	return false;
 }

/**
 * additionalInput's method is ask for additional input for
 * NON-CASH transaction for the document no. of all NON-CASH
 * except TRANSFER.
 * @param int index, String input, Encap c
 * @return none
 */
 private void additionalInput(int index,String input,Encap c)
 {
  if(input.equalsIgnoreCase("TRANSFER")) return;
  boolean condition = false;
  if(VariousCheck.checkException(c.extractAll("fieldValue"+index)))
  { // FROM CASH to NON-CASH
   if(!VariousCheck.checkException(input)) // make sure it is non-cash
   {
    while(!condition)
    {
     String x = Mandalatama.questionDisplay("Enter Payment Document No.",
     "QUESTION");
     if(x != null)
     {
      if(x.length()<=32)
      {
       Encap b = new Encap("transDocument");
       b.setNameVal("transDocOfKey",c.extractInteger("key value",0));
       b.setNameVal("transDocNo",x);
       masterIns.add(b.clone());
       b.clear();
       condition = true;
      }
      else 
       Mandalatama.errorDisplay("You exceeding max of 32 characters","ERROR");
     }
    } // end of while-loop
   }
  } 
  else
  { // FROM NON-CASH to CASH
   if(VariousCheck.checkException(input)) // make sure it is cash
   {
    Encap b = new Encap("transDocument");
    b.setCondition("WHERE transDocOfKey="+c.extractInteger("key value",0)+";"); 
    masterDel.add(b.clone());
    b.clear();
   }
  }
 }

 public void close()
 {
  if(!masterMap.isEmpty()) masterMap.removeAllElements();
  if(masterPay != null) masterPay.removeAllElements();
  if(masterDate != null) masterDate.clear();
  if(masterTime != null) masterTime.clear();
  db.close();
  db = null;
  frame.dispose();
  System.gc();
 }

 private class tableData extends AbstractTableModel
 {
  public final int OLDDESC = 0;
  public final int OLDVAL  = 1;
  public final int NEWVAL  = 2;

  public int rowLength;
  public int colLength;
  public Vector dataRow;
  public final String[] colNames= {"Description",
  "Old\nValue","New\nValue"};

  public tableData(Vector ve)
  {
   rowLength = ve.size();
   colLength = colNames.length;
   initData(ve);
  } // end of tableData's constructor
  public void initData(Vector ve)
  { dataRow = ve; }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colLength; }
  public String getColumnName(int column)
  { return colNames[column]; }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public boolean isCellEditable(int row, int column)
  {
   if(column == NEWVAL)
    return true;
   return false; 
  }
  public Object getValueAt(int row, int column)
  { 
   if((row<0)||(row>=getRowCount()))
    return " ";
   Data dt = (Data)dataRow.elementAt(row);
   switch(column)
   {
    case OLDDESC: return dt.getOldDesc();
    case OLDVAL : return dt.getOldVal(); 
    case NEWVAL : return dt.getNewVal();
   }
   return " "; 
  }
  public void setValueAt(Object val, int row, int column)
  {
   Data dt = (Data)dataRow.elementAt(row);
   switch(column)
   {
    case OLDDESC : dt.setOldDesc((String)val); break;
    case OLDVAL  : dt.setOldVal((String)val); break;
    case NEWVAL  : dt.setNewVal((String)val); break;
   }
   dataRow.setElementAt(dt,row);
   fireTableCellUpdated(row,column);
  } 
 } // end of tableData's class

 private class Data
 {
  private String oldDesc;
  private String oldVal;
  private String newVal;

  public Data()
  { } 
  public Data(String od,String ov,String nv)
  {
   setOldDesc(od);
   setOldVal(ov);
   setNewVal(nv);
  }
  public void setOldDesc(String od)
  { oldDesc = new String(od); }
  public void setOldVal(String ov)
  { oldVal = new String(ov); }
  public void setNewVal(String nv)
  { newVal = new String(nv); }
  public String getOldDesc()
  { return oldDesc; }
  public String getOldVal()
  { return oldVal; } 
  public String getNewVal()
  { return newVal; }
 }
}
