import java.sql.SQLException;
import java.util.StringTokenizer;
import java.util.Vector;
import java.io.*;

public class ProcessPrintReport
{

 DBConnect db = new DBConnect();
 private String date = null;
 private String bdate= null;
 private String edate= null;
 private String finalName = null;
 private String currentDate = null;
 private StringBuffer error = new StringBuffer(128);
 private StringBuffer tBalance = new StringBuffer(256);
 private int hashTime = 0;
 private int action = 0;
 private File htmlFile = null;
 private Vector result = null; // For CASH
 private Vector result2= null; // For NON-CASH
 private boolean turnKey = false;
 private MultipleCurrency mcb = 
	new MultipleCurrency(Mandalatama.typeCurrency);
 private MultipleCurrency mcd = 
	new MultipleCurrency(Mandalatama.typeCurrency);
 private MultipleCurrency mcc = 
	new MultipleCurrency(Mandalatama.typeCurrency);
 private StringBuffer cashBal = new StringBuffer(16);
 private StringBuffer bankBal = new StringBuffer(16);
 private boolean initCash = false;
 private boolean initBank = false;

 public ProcessPrintReport(int act,String s)
 {
  if(s == null)
  {
   Mandalatama.errorDisplay("Invalid input = null","ERROR");
   return;
  }
  if(act != Mandalatama.PSD)
  {
   Mandalatama.errorDisplay("Invalid act : "+act,"ERROR");
   return;
  }
  action = act;
  date = VariousCheck.formDate(s);
  DateUtil du = new DateUtil();
  hashTime = du.getTime().hashCode();
  Vector v = null;
  try
  {
   if(!db.makeConnection("MANDALATAMA"))
    throw new SQLException("Failure to make connection");
   v = db.QueryMulti("transPayment","*",
    "WHERE transPaymentDate=\""+date+"\";");
   refineResult(v,db);
   if(error.length() == 0)
    printFile(result);
  }
  catch(SQLException sqle)
  {
   sqle.printStackTrace();
   error.append(sqle.getMessage());
  }
  catch(IOException ioex)
  {
   ioex.printStackTrace();
   error.append(ioex.getMessage());
  }
  finally
  {
   if(error.length()>0)
   {
    Mandalatama.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
   }
   db.close();
   if(result != null) result.removeAllElements();
   du = null;
  }
 }

 private void refineResult(Vector v,DBConnect db) throws SQLException
 {
  if(v == null)
  {
   error.append("No data found for date: ");
   if(action ==Mandalatama.PSD) 
    error.append(VariousCheck.formNDate(date)+"\n");
   else
    error.append(VariousCheck.formNDate(bdate)+" TO "+
    VariousCheck.formNDate(edate));
   return;
  }
  Encap e = null;
  Encap e2= null;
  boolean valid = true;
  boolean cash = true;
  result = new Vector(v.size());
  result2= new Vector(v.size());
  while(!v.isEmpty())
  {
   e = (Encap)v.remove(0);
   e2 = db.QuerySingle("transaction","*","WHERE transKey="+
   e.extractAll("transPaymentOfKey")+";");
   if(e2 != null)
   {
    if(e2.extractAll("transValid").equalsIgnoreCase("N"))
      valid = false;
    else
      valid = true;
    if(valid)
    {
     e.setNameVal("transKey",e2.extractInteger("transKey",0));
     e.setNameVal("transInvoiceNo",e2.extractInteger("transInvoiceNo",0));
     e.setNameVal("transDescription",e2.extractString("transDescription",null));
     if(!VariousCheck.checkException(e.extractAll("transPaymentMethod")))
      cash = false;
     else
      cash = true;
    }
    e2.clear();
   }

   if(valid)
   {
    e2 = db.QuerySingle("transRemarks","*","WHERE transRemarksOfKey="+
    e.extractAll("transPaymentKey")+";");
    if(e2 != null)
    {
     e.setNameVal("transRemarksContent",
     e2.extractString("transRemarksContent",null));
     e2.clear();
    }
    if(cash)
     result.add(e.clone());
    else
     result2.add(e.clone());
   }
   e.clear();
  }
  mcb.clearVariable();
  mcc.clearVariable();
  mcd.clearVariable();
  fetchBalance();
 } // end of refineResult's method

 private void printFile(Vector v) throws IOException
 {
  String filename = null;
  filename = new String("CASH-"+date+"#"+hashTime+".HTML");
  htmlFile = formFile(filename);
  if(htmlFile == null) throw new IOException(error.toString());
  FileWriter fw = new FileWriter(htmlFile);
  BufferedWriter bw = new BufferedWriter(fw);
  PrintWriter pw = new PrintWriter(bw);

  // --- BEGIN WRITING ---
  pw.print("<HTML><HEAD><TITLE>CASH BOOK FOR ");
  pw.println(VariousCheck.formNDate(date)+"</TITLE></HEAD>");
  pw.println("<BODY BGCOLOR=WHITE TEXT=BLACK>");
  pw.println("<BR></BR>");

  // --- CASH ----
  writeHeading(pw);
  writeBody(pw,result);
  turnKey = true;
  pw.println("</TABLE></P><BR></BR><BR></BR>");

  // --- BANK ----
  writeHeading(pw);
  writeBody(pw,result2);
  pw.println("</TABLE></P>");

  pw.println("</BODY></HTML>");
  pw.flush();
  pw.close();
  bw.close();
  fw.close();
  Runtime rt = Runtime.getRuntime();
  rt.exec("C:"+File.separator+"Program Files"+File.separator+
  "Internet Explorer"+File.separator+"iexplore "+finalName);
 }

 private void fetchBalance() throws SQLException
 {
  fetchBankBalance();
  fetchCashBalance();
 }

 private void fetchCashBalance() throws SQLException
 {
  int a = 0;
  int b = 0;
  int con = 0;
  Encap e = null;
  Vector v = null;
  int len = Mandalatama.typeCurrency.length;

  v = db.QueryMulti("transInitialBalance","*",
  "WHERE transInitialDate=\""+date+"\";");
  if(v != null)
  {
   System.out.println("found initial cash balance");
   while(!v.isEmpty())
   {
    e = (Encap)v.remove(0);
    mcb.sumAR(e.extractAll("transInitialCurrency"),
    e.extractAll("transInitialAmount"));
    cashBal.append(e.extractAll("transInitialCurrency")+" "+
    VariousCheck.formNumDelimiter(e.extractAll("transInitialAmount"))+" ");
    e.clear();
   }
   initCash = true;
   return;
  }
  v = db.QueryMulti("transBalance","*",
  "WHERE transBalanceDate=\""+date+"\";");
  if(v == null) return;
    
  e = (Encap)v.firstElement();
  con = e.extractInteger("transBalanceKey",0);
  System.out.println("BalanceKey = "+con+" len = "+len);
  if(con - len < 0) return;
  a = con - len;
  b = con - 1; 
  if(a == 0) a = 1;
  System.out.println("a = "+a+" b = "+b);
  v.removeAllElements();
  v = db.QueryMulti("transBalance","*",
  "WHERE transBalanceKey>=\""+a+"\" AND "+
  "transBalanceKey<=\""+b+"\";");
  if(v == null) return;
  e.clear();
  while(!v.isEmpty())
  {
   e = (Encap)v.remove(0);
   mcb.sumAR(e.extractAll("transBalanceCurrency"),
    e.extractAll("transBalanceAmount"));	
   cashBal.append(e.extractAll("transBalanceCurrency")+" "+
   VariousCheck.formNumDelimiter(e.extractAll("transBalanceAmount"))+"<BR>");
   e.clear();
  }
 }


 private void fetchBankBalance() throws SQLException
 {
  Encap e = null;
  Vector v = null;
  int con = 0;
  int a = 0;
  int b = 0;
  int len = Mandalatama.typeCurrency.length;

  v = db.QueryMulti("transInitialBankBalance","*",
  "WHERE transInitialBankBalDate=\""+date+"\";");
  if(v != null)
  {
   while(!v.isEmpty())
   {
    e = (Encap)v.remove(0);
    mcb.sumAP(e.extractAll("transInitialBankBalCurrency"),
    e.extractAll("transInitialBankBalAmount"));
    bankBal.append(e.extractAll("transInitialBankBalCurrency")+" "+
    VariousCheck.formNumDelimiter(e.extractAll("transInitialBankBalAmount"))+
	 "<BR>");
    e.clear();
   }
   initBank = true;
   return;
  }
  v = db.QueryMulti("transBankBalance","*",
  "WHERE transBankBalDate=\""+date+"\";");
  if(v == null) return;
    
  e = (Encap)v.firstElement();
  con = e.extractInteger("transBankBalKey",0);
  if(con - len < 0) return;
  a = con - len;
  b = con - 1; 
  if(a == 0) a = 1;
  v.removeAllElements();
  v = db.QueryMulti("transBankBalance","*",
  "WHERE transBankBalKey>=\""+a+"\" AND "+
  "transBankBalKey<=\""+b+"\";");
  if(v == null) return;
  e.clear();
  while(!v.isEmpty())
  {
   e = (Encap)v.remove(0);
   mcb.sumAP(e.extractAll("transBankBalCurrency"),
    e.extractAll("transBankBalAmount"));	
   bankBal.append(e.extractAll("transBankBalCurrency")+" "+
   VariousCheck.formNumDelimiter(e.extractAll("transBankBalAmount"))+"<BR>");
   e.clear();
  }
 }

 private void writeHeading(PrintWriter pw) throws IOException
 {
  pw.println("<P><TABLE BORDER=1 CELLPADDING=1 CELLSPACING=1 WIDTH=\"90%\">");
	pw.print("<CAPTION>");
  if(!turnKey) // CASH
	 pw.print("CASH TRANSACTION FOR ");
	else
	 pw.print("NON-CASH TRANSACTION FOR ");
  pw.print(VariousCheck.formNDate(date));
  pw.print("</CAPTION>");
  pw.println("<TR>");
  pw.print("<TH WIDTH=\"5%\"><B><FONT SIZE=\"-1\">Trans Key</FONT></B></TH>");
  pw.print("<TH WIDTH=\"5%\"><B><FONT SIZE=\"-1\">Invoice No</FONT></B></TH>");
  pw.print("<TH WIDTH=\"45%\"><B><FONT SIZE=\"-1\">");
	pw.print("Description/Remarks");
	if(turnKey) // non-cash
	 pw.print("/Payment Method");
	pw.print("</FONT></B></TH>");
  pw.print("<TH WIDTH=\"15%\"><B><FOTN SIZE=\"-1\">DEBIT</FONT></B></TH>");
  pw.print("<TH WIDTH=\"15%\"><B><FOTN SIZE=\"-1\">CREDIT</FONT></B></TH>");
  pw.print("<TH WIDTH=\"15%\"><B><FOTN SIZE=\"-1\">BALANCE</FONT></B></TH>");
  pw.println("</TR>");
 }


 private void writeBody(PrintWriter pw,Vector v) throws IOException
 {
  int size = v.size();
  Encap e = null;
  int transKey = 0;
  int pos = 0;
  StringBuffer curr = new StringBuffer(3);
  StringBuffer amnt = new StringBuffer(16);

  for(int i=0;i<size;i++)
  {
   e = (Encap)v.get(i);
   pw.println("<TR>");
   pw.print("<TD WIDTH=\"5%\"><FONT SIZE=\"-1\">"+e.extractAll("transKey")+
   "</FONT></TD>");
   pw.print("<TD WIDTH=\"5%\"><FONT SIZE=\"-1\">"+
	 e.extractAll("transInvoiceNo")+"</FONT></TD>");
   pw.print("<TD WIDTH=\"45%\"><FONT SIZE=\"-2\">"+
	 e.extractAll("transDescription"));   
   if(e.getPosition("transRemarksContent")>=0)
     pw.print("<i> ["+e.extractAll("transRemarksContent")+"]</i>");
	 if(turnKey)
    pw.print(" ("+e.extractAll("transPaymentMethod")+")");
   pw.print("</FONT></TD>");
   curr.append(e.extractAll("transPaymentCurr"));
   amnt.append(e.extractAll("transPaymentAmnt"));

   if(e.extractAll("transPaymentType").equalsIgnoreCase("DEBIT"))
   {
    pw.print("<TD WIDTH=\"15%\">");
    pw.print("<TABLE BORDER=0 WIDTH=\"100%\"><TR>");
    pw.print("<TD WIDTH=\"30%\" ALIGN=LEFT><FONT SIZE=\"-1\">");
    pw.print(curr.toString()+"</FONT></TD>");
    pw.print("<TD WIDTH=\"70%\" ALIGN=RIGHT><FONT SIZE=\"-1\">");
    pw.print(VariousCheck.formNumDelimiter(amnt.toString())+"</FONT></TD>");
    pw.print("</TR></TABLE></TD>");
    pw.print("<TD WIDTH=\"15%\"><CENTER>--</CENTER></TD>");
    if(!turnKey) // CASH 
    {
     mcd.sumAR(curr.toString(),amnt.toString());
     mcb.sumAR(curr.toString(),amnt.toString());
    }
    else
    {
     mcd.sumAP(curr.toString(),amnt.toString());
     mcb.sumAP(curr.toString(),amnt.toString());
    }
   }
   else // CREDIT
   {
    pw.print("<TD WIDTH=\"15%\"><CENTER>--</CENTER></TD>");
    pw.print("<TD WIDTH=\"15%\">");
    pw.print("<TABLE BORDER=0 WIDTH=\"100%\"><TR>");
    pw.print("<TD WIDTH=\"30%\" ALIGN=LEFT><FONT SIZE=\"-1\">");
    pw.print(curr.toString()+"</FONT></TD>");
    pw.print("<TD WIDTH=\"70%\" ALIGN=RIGHT><FONT SIZE=\"-1\">");
    pw.print(VariousCheck.formNumDelimiter(amnt.toString())+"</FONT></TD>");
    pw.print("</TR></TABLE></TD>");
    if(!turnKey) // CASH 
    {
     mcc.subAR(curr.toString(),amnt.toString());
     mcb.subAR(curr.toString(),amnt.toString());
    }
    else
    {
     mcc.subAP(curr.toString(),amnt.toString());
     mcb.subAP(curr.toString(),amnt.toString());
    } 
   }
   // BALANCE
   pw.print("<TD WIDTH=\"15%\">");
   pw.print("<TABLE BORDER=0 WIDTH=\"100%\"><TR>");
   pw.print("<TD WIDTH=\"30%\" ALIGN=LEFT><FONT SIZE=\"-1\">");
   pw.print(curr.toString()+"</FONT></TD>");
   pw.print("<TD WIDTH=\"30%\" ALIGN=RIGHT><FONT SIZE=\"-1\">");
   if(!turnKey) // CASH
    pw.print(VariousCheck.formNumDelimiter(
		 mcb.getSumAR(mcb.getCurr(curr.toString())).toString())); 
   else
    pw.print(VariousCheck.formNumDelimiter(
		 mcb.getSumAP(mcb.getCurr(curr.toString())).toString()));
   pw.print("</FONT></TD></TABLE></TD>");
   pw.println("</TR>");
   e.clear();
   curr.delete(0,curr.length());
   amnt.delete(0,amnt.length());
  }
  writeTotal(pw);
 }

 private void writeTotal(PrintWriter pw) throws IOException
 {
  int len = Mandalatama.typeCurrency.length;
  for(int i=0;i<len;i++)
  {
   pw.println("<TR>");
   pw.print("<TD WIDTH=\"5%\"></TD><TD WIDTH=\"5%\"></TD>");
   pw.print("<TD WIDTH=\"45%\"><FONT SIZE=\"-1\"><B>Total</B></FONT></TD>");

   // --- DEBIT ---
   pw.print("<TD WIDTH=\"15%\">"); 
   pw.print("<TABLE BORDER=0 WIDTH=\"100%\"><TR>");
   pw.print("<TD WIDTH=\"30%\" ALIGN=LEFT><FONT SIZE=\"-1\"><B>");
   pw.print(mcd.getCurr(i)+"</B></FONT></TD>");
   pw.print("<TD WIDTH=\"70%\" ALIGN=RIGHT><FONT SIZE=\"-1\"><B>");
   if(!turnKey) // CASH
    pw.print(VariousCheck.formNumDelimiter(mcd.getSumAR(i).toString())+
		"</B></FONT></TD></TR>");
   else
    pw.print(VariousCheck.formNumDelimiter(mcd.getSumAP(i).toString())+
		"</B></FONT></TD></TR>");
   pw.print("</TABLE></TD>");

   // --- CREDIT --- 
   pw.print("<TD WIDTH=\"15%\">");
   pw.print("<TABLE BORDER=0 WIDTH=\"100%\"><TR>");
   pw.print("<TD WIDTH=\"30%\" ALIGN=LEFT><FONT SIZE=\"-1\"><B>");
   pw.print(mcc.getCurr(i)+"</B></FONT></TD>");
   pw.print("<TD WIDTH=\"70%\" ALIGN=RIGHT><FONT SIZE=\"-1\"><B>");
   if(!turnKey) // CASH
    pw.print(VariousCheck.formNumDelimiter(mcc.getSumAR(i).toString())+
		"</B></FONT></TD></TR>");
   else
    pw.print(VariousCheck.formNumDelimiter(mcc.getSumAP(i).toString())+
		"</B></FONT></TD></TR>");
   pw.print("</TABLE></TD>");
   
   // --- BALANCE ---
   pw.print("<TD WIDTH=\"15%\">");
   pw.print("<TABLE BORDER=0 WIDTH=\"100%\"><TR>");
   pw.print("<TD WIDTH=\"30%\" ALIGN=LEFT><FONT SIZE=\"-1\"><B>");
   pw.print(mcb.getCurr(i)+"</B></FONT></TD>");
   pw.print("<TD WIDTH=\"70%\" ALIGN=RIGHT><FONT SIZE=\"-1\"><B>");
   if(!turnKey) // CASH
    pw.print(VariousCheck.formNumDelimiter(mcb.getSumAR(i).toString())+
		"</B></FONT></TD></TR>");
   else
    pw.print(VariousCheck.formNumDelimiter(mcb.getSumAP(i).toString())+
		"</B></FONT></TD></TR>");
   pw.print("</TABLE></TD>");
   pw.println("</TR>");
  }
  
  // --- WRITE INITIAL BALANCE ---
  if(!turnKey)
  {
   pw.println("<TR>");
   pw.print("<TD WIDTH=\"5%\"></TD><TD WIDTH=\"5%\"></TD>");
   pw.print("<TD WIDTH=\"45%\"><FONT SIZE=\"-1\"><B>");
   if(initCash) 
    pw.print("New Initial Cash Balance");
   else
    pw.print("Previous Cash Balance");
   pw.print("</B></FONT></TD>");
   pw.print("<TD WIDTH=\"15%\"></TD><TD WIDTH=\"15%\"></TD>"); 
   pw.print("<TD WIDTH=\"15%\"><FONT SIZE=\"-1\"><B>"); 
   pw.print(cashBal.toString()+"</B></FONT></TD>"); 
   pw.println("</TR>");
  }
  else
  {
   pw.println("<TR>");
   pw.print("<TD WIDTH=\"5%\"></TD><TD WIDTH=\"5%\"></TD>");
   pw.print("<TD WIDTH=\"45%\"><FONT SIZE=\"-1\"><B>");
   if(initBank) 
    pw.print("New Initial Bank Balance");
   else
    pw.print("Previous Bank Balance");
   pw.print("</B></FONT></TD>");
   pw.print("<TD WIDTH=\"15%\"></TD><TD WIDTH=\"15%\"></TD>"); 
   pw.print("<TD WIDTH=\"15%\"><FONT SIZE=\"-1\"><B>"); 
   pw.print(bankBal.toString()+"</B></FONT></TD>"); 
   pw.println("</TR>");
  }
 }

 public File formFile(String name) throws IOException
 {
  String tmpDir = new String("C:"+File.separator+"CASHBOOK"+
  File.separator);
  File dirName = new File(tmpDir);
  if(!dirName.exists()) dirName.mkdirs();
  int last = 0;
  int lpos = 0;
  File tmp = new File(dirName,name);
  StringBuffer str = new StringBuffer(64);
  str.append(name);
  DateUtil du = new DateUtil();
  do
  {
   if(tmp.exists())
   {
    hashTime = du.getTime().hashCode();
    lpos = str.toString().lastIndexOf('#');
    str.delete(lpos+1,str.length());
    str.append(hashTime+".HTML");
    if(tmp.renameTo(new File(tmpDir,str.toString())))
     finalName = tmpDir+str.toString();
   }
   else
   {
    tmp.createNewFile();
    finalName = tmpDir+str.toString();
    break;
   }
  }while(tmp.exists());
  du = null;
  return tmp;
 }

}
