import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.sql.SQLException;

public class ProcessUser
{
 private int action;
 private JFrame frame;
 private JButton submitButton;
 private JButton cancelButton;
 private JTextField newName1;
 private JTextField newName2;
 private JPasswordField newPass1;
 private JPasswordField retypeP1;
 private JPasswordField newPass2;
 private JPasswordField retypeP2;
 private JComboBox newAccess1;
 private JComboBox newLevel1;
 private JComboBox newLevel2;
 private String[] access = {"Y","N"};
 private String[] accLvl = {"3","2","1"};
 private JComboBox userList;
 private Encap en;
 private Encap fen;
 private int userLvl;

 public ProcessUser(int act,int user)
 {
  action = act;
  userLvl= user;
  en = new Encap("authorizedUser");
  fen= new Encap("authorizedUser");
  frame = new JFrame();
  frame.getContentPane().setLayout(new BorderLayout());
  initJCombo(act);
  initJText(act);
  if(action == Mandalatama.REMUSR)
  {
   frame.setTitle("Modify Authorized User");
   frame.getContentPane().add(createRemMain(),BorderLayout.CENTER);
  }
  else
  {
   frame.setTitle("Add Authorized User");
   frame.getContentPane().add(createAddMain(),BorderLayout.CENTER);
  }
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Mandalatama.infoDisplay("Click on Close in the panel instead","Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createRemMain()
 {
  JPanel panel = new JPanel();
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.NORTHWEST;
  gbc.fill = GridBagConstraints.HORIZONTAL;
  gbc.insets = new Insets(2,2,2,2);
  gbc.weightx = 1.0;
  gbc.weighty = 1.0;
  gbc.gridwidth = 2;
  panel.setLayout(gbl);
  newPass1 = new JPasswordField(10);
  retypeP1 = new JPasswordField(10);
  newPass1.setEchoChar('#');
  retypeP1.setEchoChar('#');
  panel.add(new JLabel("Username"),gbc);
  panel.add(new createComboBox(userList,false),gbc);
  gbc.gridy = 1;
  panel.add(new JLabel("New Password"),gbc);
  panel.add(newPass1,gbc);
  gbc.gridy = 2;
  panel.add(new JLabel("Retype Password"),gbc);
  panel.add(retypeP1,gbc);
  gbc.gridy = 3;
  panel.add(new JLabel("New Access Level"),gbc);
  panel.add(new createComboBox(newLevel1,false),gbc);  
  gbc.gridy = 4;
  panel.add(new JLabel("New Active Access"),gbc);
  panel.add(new createComboBox(newAccess1,false),gbc);
  return panel;
 }

 private JPanel createAddMain()
 {
  JPanel panel = new JPanel();
  panel.setLayout(new GridLayout(4,2));
  newPass2 = new JPasswordField(10);
  retypeP2 = new JPasswordField(10);
  newPass2.setEchoChar('#');
  retypeP2.setEchoChar('#');
  panel.add(new JLabel("Name Authorized User"));
  panel.add(new createTextField(newName2,32));
  panel.add(new JLabel("Password Authorized User"));
  panel.add(newPass2);
  panel.add(new JLabel("Retype Password"));
  panel.add(retypeP2);
  panel.add(new JLabel("Access Level Authorized User"));
  panel.add(new createComboBox(newLevel2,false));
  return panel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel(new FlowLayout());
  submitButton = new JButton("Submit");
  cancelButton = new JButton("Cancel");
  ButtonListener bl = new ButtonListener();
  submitButton.addActionListener(bl);
  cancelButton.addActionListener(bl);
  panel.add(submitButton);
  panel.add(cancelButton);
  return panel;
 }

 private class ButtonListener implements ActionListener
 {
  StringBuffer error = new StringBuffer();

  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == submitButton)
   {
    if(action == Mandalatama.ADDUSR)
     collectADD();    
    else
     collectREM();
    if(error.length()==0)
     process();
    else
     Mandalatama.errorDisplay(error.toString(),"ERROR");
    if(error.length()==0) 
    {
     Mandalatama.infoDisplay("Your request is successfully processed",
       "SUCCESS");
     close();
    }
   }
   else
    close();
  }

  public void collectADD()
  {
   String p1 = null;
   String p2 = null;

   if(newName2.getText().length()>=1)
   {
    if(!checkExisting("authorizedName",newName2.getText()))
     fen.setNameVal("authorizedName",newName2.getText().trim());
    else
     error.append("The name is already exist in database.\n");
   }
   else
    error.append("You must fill authorized user\n");
   if(newPass2.getPassword().length==0)
    error.append("You must fill the password\n");
   else if(newPass2.getPassword().length<6||newPass2.getPassword().length>16)
    error.append("Password must be between 6-16 characters\n");
   else
    p1 = new String(newPass2.getPassword());
   if(retypeP2.getPassword().length==0)
    error.append("You must retype the password to confirm\n");
   else if(retypeP2.getPassword().length<6||retypeP2.getPassword().length>16)
    error.append("Retype Password must be between 6-16 characters\n");
   else
    p2 = new String(retypeP2.getPassword());
   if(error.length()==0&&p1!=null&&p2!=null)
   {
    if(checkSimiliar(p1,p2))
     fen.setNameVal("authorizedPassKey","PASSWORD(\'"+p1+"\')"); 
    else
     error.append("The new password does not confirm. Retype again\n");
   }
   int pos = en.getPosition("AddLevel");
   if(pos>=0)
    fen.setNameVal("authorizedLevel",en.getStringValue(pos));
   else
    error.append("You must fill the authorized level\n");

   DBConnect.viewEncap(fen);
   System.out.println("----");
  }

  public void collectREM()
  {
   int pos = en.getPosition("username");
   String tmp = en.getStringValue(pos);
   if(tmp.compareToIgnoreCase(" ")==0)
    error.append("You must choose username\n");
   else
   {
    fen.setNameVal("authorizedName",tmp.trim()); 
    fen.setCondition("WHERE authorizedName=\""+tmp+"\";");
   }
   String p1 = null;
   String p2 = null;
   if(newPass1.getPassword().length>=1)
    if(newPass1.getPassword().length>=6 && newPass1.getPassword().length<=16)
     p1 = new String(newPass1.getPassword()); 
   if(retypeP1.getPassword().length>=1)
    if(retypeP1.getPassword().length>=6 && retypeP1.getPassword().length<=16)
     p2 = new String(retypeP1.getPassword());
   if(p1!=null&&p2!=null)
   {
    if(checkSimiliar(p1,p2))
     fen.setNameVal("authorizedPassKey","PASSWORD(\'"+p1+"\')");
    else
     error.append("The new password does not confirm. Retype again\n");
   }
   pos = en.getPosition("RemAccess");
   if(pos>=0)
    fen.setNameVal("authorizedValid",en.getStringValue(pos));
   pos = en.getPosition("RemLevel");
   if(pos>=0)
    fen.setNameVal("authorizedLevel",en.getStringValue(pos));
  }

  private boolean checkSimiliar(String s1,String s2)
  {
   if(s1.compareTo(s2)==0) return true;
   return false;
  }

  private boolean checkExisting(String colName,String colVal)
  {
   DBConnect db = new DBConnect();
   Encap en = null;
   boolean found = true;
   try
   {
    if(!db.makeConnection("MANDALATAMA"))
     throw new SQLException("Failure to make connection to database\n");
    en = db.QuerySingle("authorizedUser","*","WHERE "+colName+"=\""+colVal+"\";");
    if(en == null) found = false;
   }
   catch(SQLException sqle)
   {
    sqle.printStackTrace(System.out);
    error.append(sqle.getMessage());
   }
   finally
   {
    if(en!=null) en.clear();
    en = null;
    db.close();
   }
   return found;
  }

  public void process()
  {
   DBConnect db = new DBConnect();
   if(!db.makeConnection("MANDALATAMA"))
   {
    error.append("Error in making connection\n");
    return;
   }
   try
   {
    if(action == Mandalatama.ADDUSR)
     db.InsertData(fen); 
    else
     db.UpdateData(fen);
   }
   catch(SQLException sqle)
   {
    sqle.printStackTrace(System.out);
    error.append(sqle.getMessage());
   }
   finally
   {
    db.close();
   }
  }

  public void close()
  {
   frame.dispose();
   System.gc();
  }
 }

 private Vector fetchUser(int lvl)
 {
  DBConnect db = new DBConnect();
  if(!db.makeConnection("MANDALATAMA"))
  {
   Mandalatama.errorDisplay("Can\'t make connection to database","ERROR");
   System.exit(0);
  }
  Vector v = null;
  Vector p = new Vector();
  try
  {
   v = db.QueryMulti("authorizedUser","*","WHERE authorizedLevel>="+lvl+";");
   if(v == null)
   {
    p.add(new String(" "));
   }
   else
   {
    Encap en1 = null;
    while(!v.isEmpty())
    {
     en1 = (Encap)v.remove(0);
     String name = en1.extractString("authorizedName",null); 
     if(name.compareToIgnoreCase("admin")!=0)
      p.add(name);
     en1.clear();
    }
   }
  }
  catch(SQLException sqle)
  {
   Mandalatama.errorDisplay(sqle.getMessage(),"ERROR in processing");
   sqle.printStackTrace(System.out);
  }
  finally
  {
   db.close();
  }
  return p; 
 }

 private void initJCombo(int act)
 {
  if(act == Mandalatama.REMUSR)
  {
   newAccess1 = new JComboBox(access);
   newLevel1  = new JComboBox(accLvl);
   userList = new JComboBox(fetchUser(userLvl));
  }
  else
  {
   newLevel2  = new JComboBox(accLvl);
  }
 }

 private void initJText(int act)
 {
  if(act == Mandalatama.ADDUSR)
   newName2 = new JTextField(10);
  else
   newName1 = new JTextField(10);
 }

 private class DocumentListen implements DocumentListener
 {
  public void changedUpdate(DocumentEvent de)
  {
   try { } catch(Exception e) { }
  }
  public void insertUpdate(DocumentEvent de)
  {
   try { } catch(Exception e) { }
  }
  public void removeUpdate(DocumentEvent de)
  {
   try { } catch(Exception e) { }
  }
 }

 private class JTextFieldLimit extends PlainDocument
 {
  private int limit;
  public JTextFieldLimit(int lim)
  {
   super();
   limit = lim;
  }
  public void insertString(int offset,String str,AttributeSet attr)
   throws BadLocationException
  {
   if(str == null) return;
   if((getLength()+str.length())<=limit)
   super.insertString(offset,str,attr);
  }
 }

 private class ComboListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JComboBox jc = (JComboBox)e.getSource();
   String source= (String)jc.getSelectedItem();
   int pos = 0;
   if(jc == newAccess1)
   {
    pos= en.getPosition("RemAccess");
    if(pos>=0) en.removeNameVal(pos);
    en.setNameVal("RemAccess",source);
   }
   else if(jc == newLevel1)
   {
    pos= en.getPosition("RemLevel");
    if(pos>=0) en.removeNameVal(pos);
    en.setNameVal("RemLevel",source);
   }
   else if(jc == newLevel2)
   {
    pos=en.getPosition("AddLevel");
    if(pos>=0) en.removeNameVal(pos);
    en.setNameVal("AddLevel",source);
   }
   else if(jc == userList)
   {
    pos= en.getPosition("username");
    if(pos>=0) en.removeNameVal(pos);
    en.setNameVal("username",source);
   }
  }
 }

 private class createComboBox extends JPanel
 {
  public createComboBox(JComboBox choice,boolean edit)
  {
   setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
   choice.setEditable(edit);
   choice.setAlignmentX(LEFT_ALIGNMENT);
   choice.addActionListener(new ComboListener());
   choice.setSelectedIndex(0);
   add(choice);
  }
 }

 private class createTextField extends JPanel
 {
  public createTextField(JTextField text, int lim)
  {
   setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
   text.setHorizontalAlignment(SwingConstants.LEFT);
   text.setDocument(new JTextFieldLimit(lim));
   text.getDocument().addDocumentListener(new DocumentListen());
   add(text);
  }
 }

}
