import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.util.Vector;
import java.math.BigDecimal;
import java.sql.SQLException;

public class ViewBySingleDate
{
 private JTable table;
 private JFrame frame;
 private tableData td;
 private JButton refreshButton;
 private JButton closeButton;

 private StringBuffer begin = new StringBuffer(24);
 private StringBuffer saldo = new StringBuffer(24);
 private StringBuffer debit = new StringBuffer(24);
 private StringBuffer credit = new StringBuffer(24);
 private StringBuffer bankBG = new StringBuffer(24);
 private StringBuffer bankCR = new StringBuffer(24);
 private StringBuffer bankDB = new StringBuffer(24);
 private StringBuffer bankSD = new StringBuffer(24);

 private JLabel labelBegin = new JLabel();
 private JLabel labelDebit = new JLabel();
 private JLabel labelCredit= new JLabel();
 private JLabel labelSaldo = new JLabel();
 private JLabel labelBankBG= new JLabel();
 private JLabel labelBankCR= new JLabel();
 private JLabel labelBankDB= new JLabel();
 private JLabel labelBankSD= new JLabel();

 // initial cash/bank
 private MultipleCurrency mci = 
  new MultipleCurrency(Mandalatama.typeCurrency);
 // credit cash/bank
 private MultipleCurrency mcc = 
  new MultipleCurrency(Mandalatama.typeCurrency);
 // debit cash/bank
 private MultipleCurrency mcd = 
  new MultipleCurrency(Mandalatama.typeCurrency);
 // balance cash/bank
 private MultipleCurrency mcb = 
  new MultipleCurrency(Mandalatama.typeCurrency);

 private String bdate = null;
 private String bbdate= null;
 private String date1 = null;
 private JList head = null;
 private Vector data = null;
 private String condition = null;
 private StringBuffer error = new StringBuffer();
 private SortedColumnHeaderRenderer schr = null;
 private SortedTableModel sortedModel = null;
 
 public ViewBySingleDate(String d1)
 {
  if(d1==null||d1.length()>10||d1.length()<8)
  {
   Mandalatama.errorDisplay("Received null date or error date",
   "ERROR Receiving");
   System.gc();
   return;
  }
  date1 = new String(d1);
  getData(d1);
  if(error.length()>0)
  {
   Mandalatama.infoDisplay(error.toString(),"Info");
   error.delete(0,error.length());
   System.gc();
   return;
  }
  frame = new JFrame("View Data by "+VariousCheck.formNDate(d1));
  frame.addWindowListener(new WindowAdapter()
  {
   public void windowClosing(WindowEvent e)
   {
    Mandalatama.infoDisplay("Click on Close in the panel instead",
     "Information");
    frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    return;
   }
  });
  frame.getContentPane().setLayout(new BorderLayout());
  frame.getContentPane().add(createMain(),BorderLayout.NORTH);
  frame.getContentPane().add(createBottom(),BorderLayout.SOUTH);
  frame.pack();
  frame.setVisible(true);
 }

 private JPanel createMain()
 {
  JPanel panel = new JPanel();
  td = new tableData(data);
  sortedModel = new SortedTableModel(td);
  table = new JTable();
  table.setAutoCreateColumnsFromModel(false);
  table.setRowHeight(20);
  table.setModel(sortedModel);
  table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  MultiLineHeaderRender mlhr = new MultiLineHeaderRender();
  schr = new SortedColumnHeaderRenderer(sortedModel,mlhr);
  int len = td.getColumnCount();
  for(int i=0;i<len;i++)
  {
   TableCellRenderer render = new DefaultTableCellRenderer();
   TableCellEditor editor = new DefaultCellEditor(new JTextField());
   TableColumn column;
   if(i==td.TKEY||i==td.TINO||i==td.TICR)
    column = new TableColumn(i,3,render,editor);
	 else if(i==td.TIDC)
		column = new TableColumn(i,15,render,editor);
   else
    column = new TableColumn(i,8,render,editor);
   column.setHeaderRenderer(schr);
   table.addColumn(column);
  }
  panel.setLayout(new BorderLayout());
  head = new JList(new ListMod(data.size()));
  head.setFixedCellWidth(20);
  head.setFixedCellHeight(table.getRowHeight());
  head.setCellRenderer(new RowHeaderRenderer(table));
  JScrollPane jsp = new JScrollPane(table);
  jsp.setRowHeaderView(head);
  panel.add(jsp,BorderLayout.CENTER);
  panel.setPreferredSize(new Dimension(780,200));
  addHeaderListener();
  return panel;
 }

 private JPanel createBottom()
 {
  JPanel panel = new JPanel();
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.CENTER;
  gbc.fill = GridBagConstraints.BOTH;
  gbc.gridx = GridBagConstraints.RELATIVE;
  gbc.insets = new Insets(2,2,2,2);
  panel.setLayout(gbl);
  gbc.gridy = 0;
  panel.add(createMidBottom(),gbc);
  gbc.gridy++;
  panel.add(createEndBottom(),gbc);
  return panel;
 }

 private JPanel createEndBottom()
 {
  JPanel panel = new JPanel();
  refreshButton = new JButton("Refresh");
  closeButton = new JButton("Close");
  ButtonListener bl = new ButtonListener();
  refreshButton.addActionListener(bl);
  closeButton.addActionListener(bl);
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.CENTER;
  gbc.fill = GridBagConstraints.BOTH;
  gbc.gridx = GridBagConstraints.RELATIVE;
  gbc.insets = new Insets(2,2,2,2);
  panel.setLayout(gbl);
  panel.add(refreshButton,gbc);
  panel.add(closeButton,gbc);
  panel.setPreferredSize(new Dimension(780,40));
  return panel;
 }

 private JPanel createMidBottom()
 {
  JPanel panel = new JPanel();
  setLabel();
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  gbc.anchor = GridBagConstraints.CENTER;
  gbc.fill = GridBagConstraints.BOTH;
  gbc.gridx = GridBagConstraints.RELATIVE;
  gbc.insets = new Insets(2,2,2,2);
  panel.setLayout(gbl);
  gbc.gridwidth=4;
  gbc.gridy = 0;
  panel.add(new JLabel("Begin Balance",SwingConstants.RIGHT),gbc);
  labelBegin.setText(begin.toString());
  panel.add(labelBegin,gbc);
  panel.add(new JLabel("Begin Bank Balance",SwingConstants.RIGHT),gbc);
  labelBankBG.setText(bankBG.toString());
  panel.add(labelBankBG,gbc);
  gbc.gridy++;
  panel.add(new JLabel("Total Debit",SwingConstants.RIGHT),gbc);
  labelDebit.setText(debit.toString());
  panel.add(labelDebit,gbc);
  panel.add(new JLabel("Total Bank Debit",SwingConstants.RIGHT),gbc);
  labelBankDB.setText(bankDB.toString());
  panel.add(labelBankDB,gbc);
  gbc.gridy++;
  panel.add(new JLabel("Total Credit",SwingConstants.RIGHT),gbc);
  labelCredit.setText(credit.toString());
  panel.add(labelCredit,gbc);
  panel.add(new JLabel("Total Bank Credit",SwingConstants.RIGHT),gbc);
  labelBankCR.setText(bankCR.toString());
  panel.add(labelBankCR,gbc);
  gbc.gridy++;
  panel.add(new JLabel("Current Balance",SwingConstants.RIGHT),gbc);
  labelSaldo.setText(saldo.toString());
  panel.add(labelSaldo,gbc);
  panel.add(new JLabel("Total Bank Balance",SwingConstants.RIGHT),gbc);
  labelBankSD.setText(bankSD.toString());
  panel.add(labelBankSD,gbc);
  panel.setPreferredSize(new Dimension(680,80));
  return panel;
 }

 private void setLabel()
 {
  if(begin.length()>0) begin.delete(0,begin.length());
  if(saldo.length()>0) saldo.delete(0,saldo.length());
  if(debit.length()>0) debit.delete(0,debit.length());
  if(credit.length()>0) credit.delete(0,credit.length());
  if(bankBG.length()>0) bankBG.delete(0,bankBG.length());
  if(bankDB.length()>0) bankDB.delete(0,bankDB.length());
  if(bankCR.length()>0) bankCR.delete(0,bankCR.length());
  if(bankSD.length()>0) bankSD.delete(0,bankSD.length());

  int len = Mandalatama.typeCurrency.length;
  for(int i=0;i<len;i++)
  {
   if(mcd.checkAR(mcd.getCurr(Mandalatama.typeCurrency[i])))
   {
    debit.append(mcd.getCurr(i)+": "+
    VariousCheck.formNumDelimiter(mcd.getSumAR(i).toString())+" ");
   }
   if(mcc.checkAR(mcc.getCurr(Mandalatama.typeCurrency[i])))
   {
    credit.append(mcc.getCurr(i)+": "+
    VariousCheck.formNumDelimiter(mcc.getSumAR(i).toString())+" ");
   }
   if(mcb.checkAR(mcb.getCurr(Mandalatama.typeCurrency[i])))
   {
    saldo.append(mcb.getCurr(i)+": "+
    VariousCheck.formNumDelimiter(mcb.getSumAR(i).toString())+" ");
   }
   if(mci.checkAR(mci.getCurr(Mandalatama.typeCurrency[i])))
   {
    begin.append(mci.getCurr(i)+": "+
    VariousCheck.formNumDelimiter(mci.getSumAR(i).toString())+" ");
   }
   if(mcd.checkAP(mcd.getCurr(Mandalatama.typeCurrency[i])))
   {
    bankDB.append(mcd.getCurr(i)+": "+
    VariousCheck.formNumDelimiter(mcd.getSumAP(i).toString())+" ");
   }
   if(mcc.checkAP(mcc.getCurr(Mandalatama.typeCurrency[i])))
   {
    bankCR.append(mcc.getCurr(i)+": "+
    VariousCheck.formNumDelimiter(mcc.getSumAP(i).toString())+" ");
   }
   if(mcb.checkAP(mcb.getCurr(Mandalatama.typeCurrency[i])))
   {
    bankSD.append(mcb.getCurr(i)+": "+
    VariousCheck.formNumDelimiter(mcb.getSumAP(i).toString())+" ");
   }
   if(mci.checkAP(mci.getCurr(Mandalatama.typeCurrency[i])))
   {
    bankBG.append(mci.getCurr(i)+": "+
    VariousCheck.formNumDelimiter(mci.getSumAP(i).toString())+" ");
   }
  }
  if(begin.length()<1) begin.append("IDR: 0.00");
  else begin.append("["+bdate+"]");
  if(saldo.length()<1) saldo.append("IDR: 0.00");
  if(debit.length()<1) debit.append("IDR: 0.00");
  if(credit.length()<1) credit.append("IDR: 0.00");
  if(bankBG.length()<1) bankBG.append("IDR: 0.00");
  else bankBG.append("["+bbdate+"]");
  if(bankDB.length()<1) bankDB.append("IDR: 0.00");
  if(bankCR.length()<1) bankCR.append("IDR: 0.00");
  if(bankSD.length()<1) bankSD.append("IDR: 0.00");
 }

 private void getData(String s1)
 {
  if(s1 == null)
  {
   error.append("Received null String at getData\n");
   return;
  }
  DBConnect db = new DBConnect();
  try
  {
   if(!db.makeConnection("MANDALATAMA"))
    throw new SQLException("Failure to make connection to database\n");
   data = db.QueryMulti("transPayment","*",
   "WHERE transPaymentDate =\""+s1+"\";");
   if(data == null)
    error.append("No transaction available on the requested date\n"); 
   else
    refineResults(db);  
  }
  catch(SQLException sqle)
  {
   error.append(sqle.getMessage());
   sqle.printStackTrace(System.out);
   if(!data.isEmpty()) data.removeAllElements();
  }
  finally
  {
   db.close();
  }
 }

 private void refineResults(DBConnect db) throws SQLException
 {
  if(data == null || data.size()==0)
  {
   error.append("Data is null or empty");
   return;
  }
  Encap e = null;
  Encap e2= null;
  Encap e3= null;
  Vector v = new Vector(data.size());
  Vector v2 = null;
  Vector v3 = null;
  int key = 0;
  int pkey= 0;
  mci.clearVariable(); // initial
  mcc.clearVariable(); // credit
  mcb.clearVariable(); // balance
  mcd.clearVariable(); // debit

  boolean valid = false;
  while(!data.isEmpty())
  {
   e = (Encap)data.remove(0);
   transData t = new transData();
   pkey = e.extractInteger("transPaymentKey",0);
   key = e.extractInteger("transPaymentOfKey",0);

   t.setTransMethod(e.extractAll("transPaymentMethod"));
   t.setTransType(e.extractAll("transPaymentType"));
   t.setTransCurr(e.extractAll("transPaymentCurr"));
   t.setTransAmt(e.extractAll("transPaymentAmnt"));
   t.setTransPaymentDate(
   VariousCheck.formNDate(e.extractAll("transPaymentDate")));
   t.setTransPaymentTime(e.extractAll("transPaymentTime"));
   if(t.getTransType().equalsIgnoreCase("CREDIT"))
   {
    if(VariousCheck.checkException(t.getTransMethod()))
    {
     mcc.sumAR(t.getTransCurr(),t.getTransAmt());
     mcb.subAR(t.getTransCurr(),t.getTransAmt());
    }
    else
    {
     mcc.sumAP(t.getTransCurr(),t.getTransAmt());
     mcb.subAP(t.getTransCurr(),t.getTransAmt());
    }
   }
   else // DEBIT
   {
    if(VariousCheck.checkException(t.getTransMethod()))
    {
     mcd.sumAR(t.getTransCurr(),t.getTransAmt());
     mcb.sumAR(t.getTransCurr(),t.getTransAmt());
    }
    else
    {
     mcd.sumAP(t.getTransCurr(),t.getTransAmt());
     mcb.sumAP(t.getTransCurr(),t.getTransAmt());
    }
   }
   System.out.println("right before check trans: key:"+key);
	 // check for transaction
	 e2 = db.QuerySingle("transaction","*","WHERE transKey="+key+";");
	 if(e2 != null)
	 {
    t.setKey(key);
    t.setInvNo(e2.extractInteger("transInvoiceNo",0));
    t.setTransDesc(e2.extractString("transDescription",null));
    e2.clear();
   }

   // check for transAudit
   v3 = db.QueryMulti("transAudit","*","WHERE transAuditOfKey="+pkey+";");
   if(v3 != null)
   {
    while(!v3.isEmpty())
    {
     e2 = (Encap)v3.remove(0);
     e3 = db.QuerySingle("authorizedUser","*",
     "WHERE authorizedID="+e2.extractInteger("transAuditByID",0)+";");
     if(e3 != null)
     {
      // check to make sure auditdate/time >= transPaymentChangedDate/Time
      if(VariousCheck.compareDate(e2.extractAll("transAuditDate"),
       e.extractAll("transPaymentChangedDate"))>=0 &&
       VariousCheck.compareTime(e2.extractAll("transAuditTime"),
       e.extractAll("transPaymentChangedTime"))>=0)
      {
       t.setTransAuditName(e3.extractAll("authorizedName"));
       t.setTransAuditDate(VariousCheck.formNDate(
				e2.extractAll("transAuditDate")));
       t.setTransAuditTime(e2.extractAll("transAuditTime"));
       if(!v3.isEmpty()) // there is more than 1 auditor or next auditor
       {
        t.setTransAuditName(",");
        t.setTransAuditDate(",");
        t.setTransAuditTime(",");
       }
      }
      e3.clear();
     }
     e2.clear();
    }
   } // end of transAudit
   e.clear();
   v.add(t);
  } /// end of top while-loop
  data = (Vector)v.clone();
  v.removeAllElements();
 }

 public void close()
 {
  frame.dispose();
  System.gc();
 }

 private class ButtonListener implements ActionListener
 {
  public void actionPerformed(ActionEvent e)
  {
   JButton jb = (JButton)e.getSource();
   if(jb == refreshButton)
   {
    getData(date1); 
    if(error.length()==0)
    {
     td.initData(data);
     setLabel();
     sortedModel.clearSort();
     sortedModel.renewModel(td);
     labelBegin.setText(begin.toString());
     labelDebit.setText(debit.toString());
     labelCredit.setText(credit.toString());
     labelSaldo.setText(saldo.toString());
     labelBankCR.setText(bankCR.toString());
     labelBankDB.setText(bankDB.toString());
     labelBankSD.setText(bankSD.toString());
     labelBankBG.setText(bankBG.toString());
     SwingUtilities.updateComponentTreeUI(labelBegin);
     SwingUtilities.updateComponentTreeUI(labelDebit);
     SwingUtilities.updateComponentTreeUI(labelCredit);
     SwingUtilities.updateComponentTreeUI(labelSaldo);
     SwingUtilities.updateComponentTreeUI(labelBankCR);
     SwingUtilities.updateComponentTreeUI(labelBankDB);
     SwingUtilities.updateComponentTreeUI(labelBankSD);
     SwingUtilities.updateComponentTreeUI(labelBankBG);
     head.setModel(new ListMod(data.size()));
     table.revalidate();
     table.repaint();
     frame.invalidate();
     frame.validate();
     frame.repaint();
    }
   }
   else
    close();
   if(error.length()>0)
   {
    Mandalatama.errorDisplay(error.toString(),"ERROR");
    error.delete(0,error.length());
    close();
   }
  }
 }

 public void addHeaderListener()
 {
  table.getTableHeader().addMouseListener(new MouseAdapter()
  {
   JTableHeader header;
   public void mousePressed(MouseEvent event)
   {
    header = (JTableHeader)(event.getSource());
    int index = header.columnAtPoint(event.getPoint());
    int sortCol = header.getTable().convertColumnIndexToModel(index);
    schr.setPressedColumn(index);
    schr.setSelectedColumn(index);
    header.repaint();
    if(header.getTable().isEditing())
     header.getTable().getCellEditor().stopCellEditing();
    boolean isAscent = false;
    if(schr.DOWN == schr.getState(index))
     isAscent = true;
    ((SortedTableModel)header.getTable().getModel()).sortByColumn(
      sortCol,td.getColumnType(sortCol),isAscent);
   }

   public void mouseReleased(MouseEvent event) 
   {
    int col = header.columnAtPoint(event.getPoint());
    schr.setPressedColumn(-1);
    header.repaint();
   }
  });
 }

 private class tableData extends AbstractTableModel
 {
  public final int TKEY = 0; // Trans Key 
  public final int TINO = 1; // Trans Invoice No 
  public final int TIDC = 2; // Trans Invoice Desc 
  public final int TITY = 3; // Trans Invoice Type
  public final int TIM  = 4; // Trans Invoice Method 
  public final int TICR = 5; // Trans Invoice Currency 
  public final int TIAM = 6; // Trans Invoice Amount 
  public final int TPDT = 7; // Trans Payment Date
  public final int TPTM = 8; // Trans Payment Time
  public final int TIAN = 9; // Trans Invoice Audit Name
  public final int TIAD =10; // Trans Invoice Audit Date 
  public final int TIAT =11; // Trans Invoice Audit Time 

  public Vector dataRow = null;
  public Vector colNames= null;
  
  public tableData(Vector ve)
  {
   initColumn();
   initData(ve);
  }
  public void initData(Vector ve)
  { dataRow = ve; }
  public void initColumn()
  {
   if(colNames == null) colNames = new Vector();
   colNames.add(new String("Trans\nKey"));
   colNames.add(new String("Inv\nNo."));
   colNames.add(new String("Trans\nDesc"));
   colNames.add(new String("Trans\nType"));
   colNames.add(new String("Payment\nMethod"));
   colNames.add(new String("Payment\nCurrency"));
   colNames.add(new String("Payment\nAmount"));
   colNames.add(new String("Payment\nDate"));
   colNames.add(new String("Payment\nTime"));
   colNames.add(new String("Audit\nName"));
   colNames.add(new String("Audit\nDate"));
   colNames.add(new String("Audit\nTime"));
  }
  public int getRowCount()
  { return dataRow.size(); }
  public int getColumnCount()
  { return colNames.size(); }
  public String getColumnName(int column)
  { return (String)colNames.elementAt(column); }
  public Class getColumnClass(int column)
  { return getValueAt(0,column).getClass(); }
  public boolean isCellEditable(int row,int column)
  { return false; }
  public int getColumnType(int column)
  {
   if(column==TKEY || column==TINO) return TableSorter.INTEGER; // INTEGER 
   if(column==TIAM) return TableSorter.BIGDEC; // BIG DECIMAL 
   if(column==TPDT || column==TIAD) return TableSorter.DATE;
   if(column==TPTM || column==TIAT) return TableSorter.TIME;
   return TableSorter.STRING; // STRING
  }
  public Object getValueAt(int row,int column)
  {
   if(row<0 || row>=getRowCount())
    return " ";
   transData trans = (transData)dataRow.elementAt(row);
   switch(column)
   {
    case TKEY : return trans.getKey();
    case TINO : return trans.getInvNo();
    case TIDC : return trans.getTransDesc();
    case TITY : return trans.getTransType();	
    case TIM  : return trans.getTransMethod();
    case TICR : return trans.getTransCurr();
    case TIAM : return VariousCheck.formNumDelimiter(trans.getTransAmt());
    case TPDT : return trans.getTransPaymentDate();
    case TPTM : return trans.getTransPaymentTime();
    case TIAN : return trans.getTransAuditName();
    case TIAD : return trans.getTransAuditDate();
    case TIAT : return trans.getTransAuditTime();
   }
   return " ";
  }
  public void setValueAt(Object val,int row,int column)
  {
   if(row<0 || row>=getRowCount()) return;
   transData trans = (transData)dataRow.elementAt(row);
   switch(column)
   {
    case TKEY : trans.setKey(((Integer)val).intValue()); break;
    case TINO : trans.setInvNo(((Integer)val).intValue()); break;
    case TIDC : trans.setTransDesc((String)val); break;
    case TITY : trans.setTransType((String)val); break;
    case TIM  : trans.setTransMethod((String)val); break;
    case TICR : trans.setTransCurr((String)val); break;
    case TIAM : trans.setTransAmt((String)val); break;
    case TPDT : trans.setTransPaymentDate((String)val); break;
    case TPTM : trans.setTransPaymentTime((String)val); break;
    case TIAN : trans.setTransAuditName((String)val); break;
    case TIAD : trans.setTransAuditDate((String)val); break;
    case TIAT : trans.setTransAuditTime((String)val); break;
   }
   dataRow.setElementAt(trans,row);
   fireTableCellUpdated(row,column);
  }
 }

 public class transData
 {
  private int transKey = 0;
  private int transInv = 0;
  private String transDesc;
  private String transType;
  private String transMethod;
  private String transCurr;
  private String transAmt;
  private String transPaymentDate;
  private String transPaymentTime;
  private StringBuffer transAuditName = new StringBuffer(16);
  private StringBuffer transAuditDate = new StringBuffer(16);
  private StringBuffer transAuditTime = new StringBuffer(16);

  public transData() { }

  public transData(int key,int no,String d,
   String t,String m,String c,String a,
   String pd,String pt,String an,String ad,String at)
  {
   setKey(key);
   setInvNo(no);
   setTransType(t);
   setTransDesc(d);
   setTransMethod(m);
   setTransCurr(c);
   setTransAmt(a);
   setTransPaymentDate(pd);
   setTransPaymentTime(pt);
   setTransAuditName(an);
   setTransAuditDate(ad);
   setTransAuditTime(at);
  }
  public void setKey(int key)
  { transKey = key; }
  public void setInvNo(int no)
  { transInv = no; }
  public void setTransType(String t)
  { transType = new String(t); }
  public void setTransDesc(String d)
  { transDesc = new String(d); }
  public void setTransMethod(String m)
  { transMethod = new String(m); }
  public void setTransCurr(String c) 
  { transCurr = new String(c); }
  public void setTransAmt(String a) 
  { transAmt = new String(a); }
  public void setTransPaymentDate(String pd) 
  { transPaymentDate = new String(pd); }
  public void setTransPaymentTime(String pt) 
  { transPaymentTime = new String(pt); }
  public void setTransAuditName(String an)
  { transAuditName.append(an); }
  public void setTransAuditDate(String ad) 
  { transAuditDate.append(ad); }
  public void setTransAuditTime(String at) 
  { transAuditTime.append(at); }

  public Integer getKey()
  { return new Integer(transKey); }
  public Integer getInvNo()
  { return new Integer(transInv); }
  public String getTransDesc()
  { return transDesc; }
  public String getTransType()
  { return transType; }
  public String getTransMethod()
  { return transMethod; }
  public String getTransCurr()
  { return transCurr; }
  public String getTransAmt()
  { return transAmt; }
  public String getTransPaymentDate()
  { return transPaymentDate; }
  public String getTransPaymentTime()
  { return transPaymentTime; }
  public String getTransAuditName()
  { return transAuditName.toString(); }
  public String getTransAuditDate()
  { return transAuditDate.toString(); }
  public String getTransAuditTime()
  { return transAuditTime.toString(); }
 }
}
